#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
#                      BFLD98.TCL v1.0                     #
#                                                          #
#~~ s0y0k ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #test98 (effnet) ~~#
#                                                          #
# Desc: Replacement of bfld.tcl                            #
#                                                          #
#       This tcl allow to ban MORE than *!*@IP             #
#       For ex: for a  flooder <ip> like: A.B.C.D          #
#       The tcl try to check if ban-mask *.D can be set,   #
#       if not trying *.C.D, if not *.B.C.D, if it really  #
#       cant it set default flooder ip ie: A.B.C.D         #
#       (note: default behavior if CHECK_MAXIBAN set to 0) #
#                                                          #
#       TCL check if ban-mask ONLY MATCH flooder and also  #
#       check known bot-hosts.                             #
#       ps: It also work for ip num like 127.0.0.1         #
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#

bind flud - pub bfldr
bind flud - ctcp bfldr
bind flud - join bfldr
bind flud - nick bfldr

#-- Enable Maxi ban mask if TRUE else use default ban mask: *!*@ip
set CHECK_MAXIBAN 1

#-- do not ban known bot hosts
set CHECK_BOTS_HOST 1

#-- Set by tcl
set FLOOD_HOSTS ""

proc bfldr {nick uhost hand type channel} {
   
   global banmask botnick bannedhost 

   set fhost [lindex [split $uhost "@"] 1]
   if { [info exists bannedhost($fhost)] } { return 1 }

   set bannedhost($fhost) 1
   timer 5 "unset bannedhost($fhost)"

   if { [set botChannels $channel] == "*" } {
      set botChannels ""
      foreach ch [channels] {
         if { [onchan $nick $ch] } {
            set botChannels [concat $botChannels $ch]            
         }
      }
   }

   foreach ch $botChannels {
      set fhost [EnumMaskHost $fhost $ch]
      set banmask "*!*@$fhost"
      newchanban $ch $banmask $botnick "FL00D" 10
      putserv "kick $ch $nick" 
   }
      
   return 1
}

proc EnumMaskHost { h c } {
   global CHECK_MAXIBAN

   if { $CHECK_MAXIBAN == 0 } { 
	  return $h 
   }
      
   AddFloodHost [string toupper $h]
   
   set hp [split $h "."]
   set n [llength $hp]
   if { [ipIsNum $h] } {
      for { set i 0 } { $i < 3 } { incr i } { 
         set hm "[lrange $hp 0 $i].*"
         regsub -all " " $hm "." hm
         if { [MaskMatchFlooder $hm $c] } { return $hm }
      }
   } else {
      while { $n > 1 } {
         incr n -1
         set hm "*.[lrange $hp $n end]"
         regsub -all " " $hm "." hm
         if { [MaskMatchFlooder $hm $c] } { return $hm }
      }
      set hm [lindex $hp 0]
      if { [regsub -all "\[0-9\]" $hm "*" hm] > 0 } {
         set hm "[string range $hm 0 [string first "*" $hm]] [lrange $hp 1 end]"
         regsub -all " " $hm "." hm
         if { [MaskMatchFlooder $hm $c] } { return $hm }
      }
   }
   return $h
}

proc AddFloodHost { h } {
   global FLOOD_HOSTS
   if { [lsearch $FLOOD_HOSTS $h] == -1 } { 
      set FLOOD_HOSTS [concat $FLOOD_HOSTS $h]
      timer 10 "DelFloodHost $h"
   }
}

proc DelFloodHost { h } {
   global FLOOD_HOSTS
   if { [set n [lsearch $FLOOD_HOSTS $h]] != -1 } {
      set FLOOD_HOSTS [lreplace $FLOOD_HOSTS $n $n]
   }
}

proc MaskMatchFlooder { h c } {
   global CHECK_BOTS_HOST FLOOD_HOSTS
   set hm [string toupper $h]
   if { $CHECK_BOTS_HOST } {
      set ip "*!*@$hm"
      foreach hand [userlist b] {
         foreach hbot [gethosts $hand] {
            if { [string match $ip $hbot] } { return 0 }
         }
      }      
   }

   foreach nick [chanlist $c] {
      set nickHost [lindex [split [string toupper [getchanhost $nick $c]] "@"] 1]
      if { ([lsearch $FLOOD_HOSTS $nickHost] == -1) && ([string match $hm $nickHost]) } { return 0 }
   }

   return 1
}

proc ipIsNum {a} {

   set t [split $a "."]
   if {[llength $t] != 4} { return 0 }

   if {[string length [lindex $t 0]] > 3 ||
       [string length [lindex $t 1]] > 3 ||
       [string length [lindex $t 2]] > 3 ||
       [string length [lindex $t 4]] > 3 ||
       [lindex $t 0] > 255 ||
       [lindex $t 1] > 255 ||
       [lindex $t 2] > 255 ||
       [lindex $t 3] > 255} { return 0 }

   return 1
}

