# xdcc.tcl
# This script was writen using NotePad, pico (vi sux.. sorry guys <g>), and
# MS-DOS edit when the file got too large for NotePad.

#######################################################################
#------------------ DO NOT EDIT BELLOW THIS LINE ---------------------#
#######################################################################

#######################################################################
#------------------------------ Procedures ---------------------------#
#######################################################################
# Main DCC command parser
proc xdcc_dcc {h i a } {
  global xdcc_saveinfotimer xdcc_endnote
  set cmd [lindex $a 0]
  set pd [lindex $a 1]
  set r [lrange $a 2 end]
  switch -- $cmd {
    +packet     {
                   if {[xdcc_add_packet $pd $i]} {
                     xdcc_echo dcc $i "A new packet was added"
                   } else {
                     xdcc_echo dcc $i "Unable to add new packet"
                   }
                }

    -packet     { 
                   if {[xdcc_del_packet $pd]} {
                     xdcc_echo dcc $i "Packet deleted"
                   } else {
                     xdcc_echo dcc $i "Unable to delete packet"
                   }
                }

    +file       {
                   if {[xdcc_add_file $pd $r]} {
                     xdcc_echo dcc $i "New files were added"
                   } else {
                     xdcc_echo dcc $i "Unable to add new files"
                   }
                }

    -file       {
                   if {[xdcc_del_file $pd $r]} {
                     xdcc_echo dcc $i "File deleted"
                   } else {
                     xdcc_echo dcc $i "Unable to delete file"
                   }
                }

    list        { 
                   if {[xdcc_list_packet $i $pd]} {
                     xdcc_echo dcc $i "Packet Listed"
                   } else {
                     xdcc_echo dcc $i "Unable to list packets"
                   }
                }

    desc        {
                   if {[xdcc_set_desc $pd $r ]} {
                     xdcc_echo dcc $i "Packet description set"
                   } else {
                     xdcc_echo dcc $i "Unable to set packet description"
                   }
                }

    comment     { 
                   if {[xdcc_set_comment $pd $r]} {
                     xdcc_echo dcc $i "Packet comment set"
                   } else {
                     xdcc_echo dcc $i "Unable to set packet comment"
                   }
                }

    count       {
                   if {[xdcc_set_count $pd [lindex $r 0]]} {
                     xdcc_echo dcc $i "Packet count set"
                   } else {
                     xdcc_echo dcc $i "Unable to set packet count"
                   }
                }

    +count      {
                   if {[regexp -nocase -- {([^0-9]+)} [lindex $r 0]] || ($r == "")} { set r 1 } else { set r [lindex $r 0] }
                   if {[xdcc_add_count $pd $r]} {
                     xdcc_echo dcc $i "Packet count incremented"
                   } else {
                     xdcc_echo dcc $i "Unable to increment packet count"
                   }
                }

    -count      {
                   if {[regexp -nocase -- {([^0-9]+)} [lindex $r 0]] || ($r == "")} { set r -1 } else { set r [lindex $r 0] }
                   if {[xdcc_del_count $pd [lindex $r 0]]} {
                     xdcc_echo dcc $i "Packet count decremented"
                   } else {
                     xdcc_echo dcc $i "Unable to decrement packet count"
                   }
                }

    group       {
                   if {[xdcc_set_group $pd [lindex $r 0]]} {
                     xdcc_echo dcc $i "Packet group set"
                   } else {
                     xdcc_echo dcc $i "Unable to set packet group"
                   }
                }
    Rdate       {
                   if {[xdcc_set_rdate $pd [lindex $r 0]]} {
                     xdcc_echo dcc $i "Packet date set"
                   } else {
                     xdcc_echo dcc $i "Unable to set packet date"
                   }
                }


    save        {
                   killtimer $xdcc_saveinfotimer
                   xdcc_saveinfo
                }

    offer       {
                   xdcc_offer chan [concat $pd $r]
                }

    reload      {
                   xdcc_reload
                }

    rehash      {
                   xdcc_rehash
                }

    info        {
                   xdcc_info dcc $i
                }

    message     {
                   xdcc_message dcc $i $a
                }

    on          {
                   if {[xdcc_turnonoff 1]} {
                     xdcc_echo dcc $i "xDCC turned \002ON\002"
                   } else {
                     xdcc_echo dcc $i "Unable to turn xDCC on"
                   }
                }

    off         {
                   if {[xdcc_turnonoff 0]} {
                     xdcc_echo dcc $i "xDCC turned \002OFF\002"
                   } else {
                     xdcc_echo dcc $i "Unable to turn xDCC off"
                   }
                }

    note        {
                   set xdcc_endnote $pd 
                   xdcc_echo dcc $i "Endnote set"
                }

    status      {
                   xdcc_status dcc $i $pd
                }

    default     {
                   xdcc_echo dcc $i "$cmd is not a valid XDCC command."
                }
  }
  return 1
}

# List a packet or all the packets
proc xdcc_list_packet { i {pd ""}} {
  global xdcc_packet_info xdcc_endnote
  if {$pd != ""} {
    if {[set r [xdcc_findpacket $pd]] == -1} { return 0 }
    set packet [lindex $xdcc_packet_info $r]
    xdcc_echo dcc $i "Packet:"
    xdcc_echo dcc $i "[format "\[%3d\]" [expr $r + 1]] [lindex $packet 0]:"
    xdcc_echo dcc $i "     Get Count: [lindex $packet 2]"
    xdcc_echo dcc $i "     Group    : [lindex $packet 1]"
    xdcc_echo dcc $i "     Comment  : [lindex $packet 4]"
    xdcc_echo dcc $i "     Rdate    : [lindex $packet 5]"
    xdcc_echo dcc $i "     Files    :"
    foreach file [lindex $packet 3] {
      xdcc_echo dcc $i "          $file"
    }
  } else {
    xdcc_echo dcc $i "XDCC Packets:"
    set count 0
    foreach packet $xdcc_packet_info {
      incr count
      xdcc_echo dcc $i "[format "\[%3d\]" $count] [lindex $packet 0]:"
      xdcc_echo dcc $i "     Get Count: [lindex $packet 2]"
    xdcc_echo dcc $i "     Group    : [lindex $packet 1]"
    xdcc_echo dcc $i "     Comment  : [lindex $packet 4]"
    xdcc_echo dcc $i "     Rdate    : [lindex $packet 5]"
      xdcc_echo dcc $i "     Files    :"
      foreach file [lindex $packet 3] {
        xdcc_echo dcc $i "        $file"
      }
    }
    xdcc_echo dcc $i "Endnote: $xdcc_endnote"
  }
  return 1
}

# Status reporting command
proc xdcc_status { t w {a ""} } {
  global xdcc_packet_info xdcc_endnote xdcc_owners xdcc_enable_fil_manip xdcc_version xdcc_on
  global xdcc_croot xdcc_root files-path xdcc_offer_pause xdcc_offer_pause_timer xdcc_saveinfotime xdcc_saveinfotimer xdcc_packetinfo_file xdcc_info_file
  global xdcc_offer_tomsg xdcc_slot_num xdcc_voiced xdcc_acceptrequests xdcc_maxsend xdcc_minsend xdcc_starttime xdcc_bindctcp xdcc_selectivevoice
  global xdcc_offer_tomsgchan xdcc_voicewait
  xdcc_echo $t $w "<---------------------- xDCC Status ---------------------->"
  xdcc_echo $t $w "xDCC Script by Acrid_, version $xdcc_version"
  if {$xdcc_on} {
    xdcc_echo $t $w "xDCC is \002ON\002"
  } else {
    xdcc_echo $t $w "xDCC is \002OFF\002"
  }
  xdcc_echo $t $w "I offer on channels: [xdcc_channel match]"
  foreach chan [xdcc_channel match] {
    xdcc_echo $t $w "   $chan: [lindex [xdcc_channel info $chan] 2]"
  }
 # xdcc_echo $t $w "I have [llength $xdcc_packet_info] packets out of $xdcc_slot_num possible."
  xdcc_echo $t $w "I say \"$xdcc_endnote\" at the end of all my offers"
  xdcc_echo $t $w "xDCC Owners: $xdcc_owners"
  xdcc_echo $t $w "xDCC was started at [ctime $xdcc_starttime] ([xdcc_ago [expr [unixtime] - $xdcc_starttime]] ago)."

  if {[string tolower $a] == "all"} {
    xdcc_echo $t $w ""
    if {$xdcc_enable_fil_manip} {
      xdcc_echo $t $w "File system commands are ENABLED"
    } else {
      xdcc_echo $t $w "File system commands are DISABLED"
    }
    xdcc_echo $t $w "Correct Root Path '$xdcc_croot' based on:"
    xdcc_echo $t $w "Root Path: $xdcc_root"
    if {$xdcc_enable_fil_manip} { xdcc_echo $t $w "DCC Path: ${files-path}" }
    xdcc_echo $t $w "Pause between Offers is $xdcc_offer_pause seconds."
    if {$xdcc_on} {
      foreach tt [utimers] {
        if {[string tolower [lindex $tt 1]] == "xdcc_chanoffer"} {
          xdcc_echo $t $w "[lindex $tt 0] seconds left until next channel offer."
          break
        }
      }
    }
    xdcc_echo $t $w "Pause between xDCC Information save is $xdcc_saveinfotime minutes."
    foreach tt [timers] {
      if {[string tolower [lindex $tt 1]] == "xdcc_saveinfo"} {
        xdcc_echo $t $w "[lindex $tt 0] minutes left until next save."
        break
      }
    }
    xdcc_echo $t $w "Channels I cycle on for voice: [xdcc_channel match +cycle]"
    xdcc_echo $t $w "I check for voice every $xdcc_voicewait minute(s)"
    xdcc_echo $t $w "Saving Packet Info at '$xdcc_packetinfo_file'"
    xdcc_echo $t $w "Saving other information at '$xdcc_info_file'"
    if {$xdcc_offer_tomsg} {
      if {$xdcc_offer_tomsgchan} {
        xdcc_echo $t $w "I can offer to people via message, but they have to be on an offer channel."
      } else {
        xdcc_echo $t $w "I can offer to people via message."
      }
    } else {
      xdcc_echo $t $w "I cannot offer to people via message."
    }
    if {$xdcc_bindctcp} {
      xdcc_echo $t $w "I answer to CTCP commands as well as MSG."
    } else {
      xdcc_echo $t $w "I answer only to MSG commands."
    }
    if {$xdcc_voiced} {
      xdcc_echo $t $w "I have to be voiced before I start offering."
    } else {
      xdcc_echo $t $w "I do not have to have voice before I start offering."
    }
    if {$xdcc_acceptrequests} {
      xdcc_echo $t $w "I can accept requests to send notes to xDCC owners."
    } else {
      xdcc_echo $t $w "I will not bother xDCC owners with notes."
    }
    xdcc_echo $t $w "Max Send Rate: $xdcc_maxsend"
    xdcc_echo $t $w "Min Send Rate: $xdcc_minsend"
  }
  return 1
}  

# Message command parsing
proc xdcc_msg {n u h a} {
  set cmd [string tolower [lindex $a 0]]
  switch -- $cmd {
    get         { xdcc_msg_send $n [lindex $a 1] }
    send        { xdcc_msg_send $n [lindex $a 1] }
    info        { xdcc_info msg $n               }
    message     { xdcc_message msg $n $a         }
    index       { xdcc_msg_list $n               }
    list        { xdcc_msg_list $n               }
    default     { 
                   xdcc_echo msg $n "\002$cmd\002 is not a valid XDCC Command." 
                   return 0
                }
  }
  return 1
}

# Main CTCP Command Parsing
proc xdcc_ctcp {n u h d k a} {
  if {[string match *#* [string tolower $d]]} { return 1 }
  set cmd [string tolower [lindex $a 0]]
  switch -- $cmd {
    get         { xdcc_msg_send $n [lindex $a 1] }
    send        { xdcc_msg_send $n [lindex $a 1] }
    info        { xdcc_info msg $n               }
    message     { xdcc_message msg $n $a         }
    index       { xdcc_msg_list $n               }
    list        { xdcc_msg_list $n               }
    default     { 
                   xdcc_echo ctcp $n "ERROR \002$cmd\002 is not a valid XDCC Command."
                }
  }
  return 0
}    

# Offer to channels
proc xdcc_chanoffer { } {
  global xdcc_offer_pause xdcc_offer_pause_timer xdcc_voiced botnick
  set l { }
  set s { }
  foreach chan [xdcc_channel match +offer] {
    if {[lsearch [string tolower [channels]] $chan] == -1} { continue }
    if {!($xdcc_voiced)} {
      if {[xdcc_channel is $chan +short]} {
        lappend s $chan
      } else {
        lappend l $chan
      }
    } else {
      if {[botisop $chan] || [isvoice $botnick $chan]} {
        if {[xdcc_channel is $chan +short]} {
          lappend s $chan
        } else {
          lappend l $chan
        }
      }
    }
  }
  if {$l != {}} { xdcc_offer chan $l 0 }
  if {$s != {}} { xdcc_offer chan $s 1 }  
  set xdcc_offer_pause_timer [utimer $xdcc_offer_pause xdcc_chanoffer]
}

# Send file to someone
proc xdcc_msg_send { n i } {
  global xdcc_packet_info xdcc_croot xdcc_sendfiles
  if {[string index $i 0] == "#"} { set i [string range $i 1 end] }
  incr i -1
  if {![xdcc_validindex $i]} {
    xdcc_echo msg $n "\002$i\002 is not a packet number!"
    return 0
  }
  set packet_files [lindex [lindex $xdcc_packet_info $i] 3]
  foreach file $packet_files {
    switch [dccsend [file join ${xdcc_croot} $file] $n] {
      0 { 
           if {![info exists xdcc_sendfiles($n:[file join ${xdcc_croot} $file])]} {
             set xdcc_sendfiles($n:$[file join {xdcc_croot} $file]) [unixtime] 
           }
        }
      1 { xdcc_echo msg $n "DCC Table to full. Cannot send $file. Please try agian later." }
      2 { xdcc_echo msg $n "Cannot open socket. Cannot send $file. Please try agian later."}
      3 { xdcc_echo msg $n "Cannot find $file. Skipping."}
      4 { xdcc_echo msg $n "Send of file $file has been queued. Will send when other transfers complete." }
    }
  }
  xdcc_add_count $i 1
  return 1
}

# File has been sent to someone, calculating transfer time.
# This proc is currently broken, and badly. Anyone know how to
# fix? :)
proc xdcc_sentfile {h n f} {
  global xdcc_sendfiles xdcc_maxsend xdcc_minsend tcl_precision
  set tcl_precision 17
  if {([info exists xdcc_sendfiles($n:$f)]) && [file exists $f]} {
    set tt [expr [unixtime] - $xdcc_sendfiles($n:$f)]
    unset xdcc_sendfiles($n:$f)
    set kbps [expr round((double([file size $f]) / $tt) / 1024 * 1000) / 1000]
    if {$kbps > $xdcc_maxsend} {
      set xdcc_maxsend $kbps
    } else {
      if {$kbps < $xdcc_minsend} {
        set xdcc_minsend $kbps
      }
    }
  }
}

# Send a list of packets to someone
proc xdcc_msg_list { n } {
  global xdcc_offer_tomsg xdcc_offer_tomsgchan
  if {$xdcc_offer_tomsg} {
    if {$xdcc_offer_tomsgchan} {
      set goahead 0
      foreach chan [xdcc_channel match] {
        if {[onchan $n $chan]} {
          set goahead 1
          break
        }
      }
      if {!($goahead)} { return 0 }
    }
    xdcc_offer msg $n
    return 1
  } else {
    xdcc_echo msg $n "I have been instructed to not offer via message."
    return 0
  }
}

# Voice people on join if their nick contains the correct mask
proc xdcc_joinvoice {n u h c} {
  if {([xdcc_channel info $c] == 0) || !([botisop $c])} { return 0 }
  foreach mask [lindex [xdcc_channel info $c] 1] {
    if {[string match [string tolower $mask] [string tolower $n]]} {
      putserv "MODE $c +v $n"
      break
    }
  }
  return 0
}

# Check for voice... if none, then cycle
proc xdcc_checkvoice { } {
  global xdcc_voicewait xdcc_cycletimer botnick
  foreach chan [xdcc_channel match +cycle] {
    if {[lsearch [string tolower [channels]] [string tolower $chan]] == -1} { continue }
    if {(![isvoice $botnick $chan]) && (![botisop $chan])} { putserv "PART $chan \015\012JOIN $chan" }
  }
  set xdcc_cycletimer [timer $xdcc_voicewait xdcc_checkvoice]
  return 1
}

# Add a new, empty packet
proc xdcc_add_packet { d i } {
  global xdcc_packet_info
  #if {[llength $xdcc_packet_info] >= $xdcc_slot_num} { return 0 }
  lappend xdcc_packet_info [list $d "" 0 { } "" ""]
  return 1
}

# Add a new file to a packet
proc xdcc_add_file { d f } {
  global xdcc_packet_info
  if {[set r [xdcc_findpacket $d]] == -1} { return 0 }
  set files [lindex [lindex $xdcc_packet_info $r] 3]
  foreach file $f {
    if {[string index $file 0] == "/"} { set file [string range $file 1 end] }
    lappend files $file
  }
  return [xdcc_editpacket $d 3 $files]
}

# Delete a packet
proc xdcc_del_packet { p } {
  global xdcc_packet_info
  set dels { }
  foreach ptd $p {
    if {[xdcc_findpacket $ptd] != -1} {
      lappend dels [xdcc_findpacket $ptd]
    }
  }
  foreach num $dels {
    set xdcc_packet_info [lreplace $xdcc_packet_info $num $num]
  }
  return 1
}

# Delete a file from a packet
proc xdcc_del_file { d f } {
  global xdcc_packet_info
  if {[set r [xdcc_findpacket $d]] == -1} { return 0 }
  set files [lindex [lindex $xdcc_packet_info $r] 3]
  set dels { }
  foreach file $files {
    if {[string index $file 0] == "/"} { set file [string range $file 1 end] }
    if {[lsearch [string tolower $f] [string tolower $file]] != -1} {
      lappend dels [lsearch [string tolower $f] [string tolower $file]]
    }
  }
  foreach del $dels {
    set files [lreplace $files $del $del]
  }
  return [xdcc_editpacket $d 3 $files]
}

# Set the description for a packet
proc xdcc_set_desc { d nd } {
   return [xdcc_editpacket $d 0 $nd]
}

# Set the Rdate for a packet
proc xdcc_set_rdate { d rd } {
   return [xdcc_editpacket $d 5 $rd]
}

# Set the comment for a packet
proc xdcc_set_comment { d c } {
  return [xdcc_editpacket $d 4 $c]
}

# Set the count for a packet
proc xdcc_set_count { d c } {
  return [xdcc_editpacket $d 2 $c]
}

# Add 1 to the current count
proc xdcc_add_count { d {c 1}} {
  global xdcc_packet_info
  if {[set r [xdcc_findpacket $d]] == -1} { return 0 }
  set count [lindex [lindex $xdcc_packet_info $r] 2]
  incr count $c
  return [xdcc_editpacket $d 2 $count]
}

# Delete 1 from the current count
proc xdcc_del_count { d {c -1}} {
  global xdcc_packet_info
  if {[set r [xdcc_findpacket $d]] == -1} { return 0 }
  set count [lindex [lindex $xdcc_packet_info $r] 2]
  if {$c > 0} { set c [expr $c * -1] }
  incr count $c
  if {$count < 0} { set count 0 }
  return [xdcc_editpacket $d 2 $count]
}

# Set the Group of a packet
proc xdcc_set_group { d o } {
  return [xdcc_editpacket $d 1 $o]
}

# Find a packet index from a description.
proc xdcc_findpacket { d } {
  global xdcc_packet_info
  if {![regexp -nocase -- {([^0-9]+)} $d]} {
    if {[xdcc_validindex [expr $d - 1]]} { return [expr $d - 1] } else { return -1 }
  }
  set d [string tolower $d]
  set c 0
  set r -1
  foreach p $xdcc_packet_info {
    if {[string tolower [lindex $p 0]] == $d} {
      set r $c
      break
    }
    incr c
  }
  return $r
}

# Test whether a packet index is valid
proc xdcc_validindex { i } {
  global xdcc_packet_info
  if {($i < 0) || ($i >= [llength $xdcc_packet_info])} { return 0 }
  return 1
}

# Replace packet information
proc xdcc_editpacket { pd i n } {
  global xdcc_packet_info
  if {[set pi [xdcc_findpacket $pd]] == -1} { return 0 }
  set xdcc_packet_info [lreplace $xdcc_packet_info $pi $pi [lreplace [lindex $xdcc_packet_info $pi] $i $i $n]]
  return 1
}

# Echo back a message
proc xdcc_echo { t w m } {
  set t [string tolower $t]
  switch -- $t {
    dcc       { putdcc $w $m                          }
    msg       { puthelp "NOTICE $w :\002xDCC:\002 $m" }
    log       { putlog "#xDCC# $m"                    }
    chan      { putserv "PRIVMSG $w :$m"              }
    ctcp      { putserv "NOTICE $w :\001$m\001"       }
    default   { return 0                              }
  }
  return 1
}

# Echo back a seperator
proc xdcc_sep { t {w ""} } {
  set t [string tolower $t]
  switch -- $t {
    dcc       { return \012                                 }
    msg       { return "\015\012NOTICE $w :\002xDCC:\002 "  }
    log       { return \012                                 }
    chan      { return "\015\012PRIVMSG $w :"               }
    ctcp      { return "\015\012NOTICE $w :"                }
    default   { return \012                                 }
  }
  return 0
}

# Give a rounded size of a file/packet
proc fsize { size } {
  set type b
  if {$size >= 1024} {
    set size [expr $size / 1024]
    set type k
  }
  if {$size >= 1024} {
    set size [expr $size / 1024]
    set type M
  }
  return $size$type
}

# Save the XDCC Packet Info to disk
proc xdcc_saveinfo { } {
  global xdcc_packet_info xdcc_packetinfo_file xdcc_saveinfotime xdcc_saveinfotimer xdcc_info_file xdcc_maxsend xdcc_minsend xdcc_endnote xdcc_on
  xdcc_echo log "" "Saving xDCC info..."
  if {[file exists $xdcc_packetinfo_file]} { file delete $xdcc_packetinfo_file }
  set f [open $xdcc_packetinfo_file w]
  foreach packet $xdcc_packet_info {
    puts $f [lindex $packet 0]
    puts $f [lindex $packet 1]
    puts $f [lindex $packet 2]
    puts $f [lindex $packet 3]
    puts $f [lindex $packet 4]
    puts $f [lindex $packet 5]
  }
  flush $f
  close $f
  if {[file exists $xdcc_info_file]} { file delete $xdcc_info_file }
  set f [open $xdcc_info_file w]
  puts $f $xdcc_maxsend
  puts $f $xdcc_minsend
  puts $f $xdcc_endnote
  puts $f $xdcc_on
  flush $f
  close $f
  set xdcc_saveinfotimer [timer $xdcc_saveinfotime xdcc_saveinfo]
  xdcc_echo log "" "xDCC info saved!"
}

# Reload XDCC information from files.
proc xdcc_reload { } {
  global xdcc_packet_info xdcc_maxsend xdcc_minsend xdcc_packetinfo_file xdcc_info_file xdcc_endnote xdcc_on
  set xdcc_packet_info { }
  if {[file exists $xdcc_packetinfo_file]} {
    set f [open $xdcc_packetinfo_file r]
    while {[eof $f] != 1} {
      gets $f t1
      gets $f t2
      gets $f t3
      gets $f t4
      gets $f t5
      if {$t3 != ""} { lappend xdcc_packet_info [list $t1 $t2 $t3 $t4 $t5] }
    }
    close $f
  }

  set xdcc_maxsend 0
  set xdcc_minsend 0
  set xdcc_endnote ""
  set xdcc_on 1
  if {[file exists $xdcc_info_file]} {
    set f [open $xdcc_info_file r]
    gets $f xdcc_maxsend
    gets $f xdcc_minsend
    gets $f xdcc_endnote
    gets $f xdcc_on
    close $f
  }
  if {$xdcc_maxsend == ""} { set xdcc_maxsend -1 }
  if {$xdcc_minsend == ""} { set xdcc_minsend -1 }
  if {$xdcc_on == ""} { set xdcc_on 1 }
  return 1
}

# Reset all the timers, xdcc_sendfiles array, and binds.
proc xdcc_rehash { } {
  global xdcc_saveinfotime xdcc_saveinfotimer xdcc_sendfiles xdcc_offer_pause_timer xdcc_offer_pause
  global xdcc_enable_fil_manip xdcc_on xdcc_cycletimer xdcc_voicewait
  global xdcc_bindctcp xdcc_starttime xdcc_firsttime

  set temp { }
  foreach t [timers] {
    if {([string tolower [lindex $t 1]] == "xdcc_chanoffer") || ([string tolower [lindex $t 1]] == "xdcc_saveinfo") || ([string tolower [lindex $t 1]] == "xdcc_checkvoice")} {
      lappend temp [lindex $t 2]
    }
  }

  foreach t $temp { killtimer $t }

  set temp { }
  foreach t [utimers] {
    if {([string tolower [lindex $t 1]] == "xdcc_chanoffer") || ([string tolower [lindex $t 1]] == "xdcc_saveinfo") || ([string tolower [lindex $t 1]] == "xdcc_checkvoice")} {
      lappend temp [lindex $t 2]
    }
  }

  foreach t $temp { killutimer $t }

  set xdcc_saveinfotimer [timer $xdcc_saveinfotime xdcc_saveinfo]
  set xdcc_cycletimer [timer $xdcc_voicewait xdcc_checkvoice]
  if {$xdcc_on} { set xdcc_offer_pause_timer [utimer $xdcc_offer_pause xdcc_chanoffer] }

  xdcc_fixpath

  set xdcc_sendfiles(*) 0

  if {![info exists xdcc_starttime]} {
    set xdcc_starttime [unixtime]
  }

  if {![info exists xdcc_firsttime]} {
    set xdcc_firsttime 0
  }

  catch { unbind msg - xdcc xdcc_msg    }
  catch { unbind dcc m xdcc xdcc_dcc    }
  catch { unbind sent - * xdcc_sentfile }
  catch { unbind join - * xdcc_joinvoie }
  catch { unbind ctcp - xdcc xdcc_ctcp  }
  catch { unbind fil m xdcc xdcc_file   }

  bind msg - xdcc xdcc_msg
  bind dcc m xdcc xdcc_dcc
  bind sent - * xdcc_sentfile
  if {$xdcc_bindctcp} { bind ctcp - xdcc xdcc_ctcp }
  bind join - * xdcc_joinvoice
  if {$xdcc_enable_fil_manip} { bind fil m xdcc xdcc_fil }
}

# Send information about the script to someone.
proc xdcc_info { t w } {
  global xdcc_version
  xdcc_echo $t $w "\002<*--- XDCC Script for EggDrop ---*>\002"
  xdcc_echo $t $w "\002Writen by:\002 Acrid_ (acridcola@hotmail.com)"
  xdcc_echo $t $w "\002Version:\002 $xdcc_version"
  return 1
}

# Turn xDCC on|off
proc xdcc_turnonoff { s } {
  global xdcc_on xdcc_offer_pause_timer xdcc_offer_pause
  if {$xdcc_on == $s} { return 0 }
  if {$s} {
    set xdcc_on 1
    set xdcc_offer_pause_timer [utimer $xdcc_offer_pause xdcc_chanoffer]
  } else {
    set xdcc_on 0
    foreach t [utimers] {
      if {[string tolower [lindex $t 1]] == "xdcc_chanoffer"} {
        killutimer [lindex $t 2]
        break
      }
    }
  }
  return 1
}

# People can now message the xDCC owners! Woo hoo! <g>
proc xdcc_message { t w m } {
  global xdcc_owners xdcc_acceptrequests
  if {!($xdcc_acceptrequests)} {
    xdcc_echo $t $w "Sorry, I have been instructed to not accept messages."
    return 0
  }
  if {[string tolower $t] == "dcc"} {
    set ww [idx2hand $w]
  } else {
    set ww $w
  }
  foreach o $xdcc_owners {
    sendnote $ww $o "xDCC: $m"
  }
  xdcc_echo $t $w "Notes were sent to the xDCC owners with your message."
  return 1
}

# Calculates in a human readable format how long ago something
# happened. Thanks to StephenC for this. It is slightly modified
# (I took the "ago" out of the concat).
proc xdcc_ago { timediff } {
  #Start a trickle-down process to subdivide the time difference interval into its
  #     years/months/weeks/days/etc.
  set years ""
  set months ""
  set weeks ""
  set days ""
  set hours ""
  set minutes ""
  if { [expr $timediff >= 31536000] == 1 } {
    set years [expr int($timediff/31536000)]
    set timediff [expr $timediff-(31536000*$years)]
    if { $years > 1 } { set years [concat $years "years"] } else { set years [concat $years "year"] }
  }
  if { [expr $timediff >= 2592000] == 1 } {
    set months [expr int($timediff/2592000)]
    set timediff [expr $timediff-(2592000*$months)]
    if { $months > 1 } { set months [concat $months "months"] } else { set months [concat $months "month"] }
  }
  if { [expr $timediff >= 604800] == 1 } {
    set weeks [expr int($timediff/604800)]
    set timediff [expr $timediff-(604800*$weeks)]
    if { $weeks > 1 } { set weeks [concat $weeks "weeks"] } else { set weeks [concat $weeks "week"] }
  }
  if { [expr $timediff >= 86400] == 1 } {
    set days [expr int($timediff/86400)]
    set timediff [expr $timediff-(2592000*$days)]
    if { $days > 1 } { set days [concat $days "days"] } else { set days [concat $days "day"] }
  }
  if { [expr $timediff >= 3600] == 1 } {
    set hours [expr int($timediff/3600)]
    set timediff [expr $timediff-(3600*$hours)]
    if { $hours > 1 } { set hours [concat $hours "hours"] } else { set hours [concat $hours "hour"] }
  }
  if { [expr $timediff >= 60] == 1 } {
    set minutes [expr int($timediff/60)]
    set timediff [expr $timediff-(60*$minutes)]
    if { $minutes > 1 } { set minutes [concat $minutes "minutes"] } else {set minutes [concat $minutes "minute"] }
  }
  #Concatenate the resulting string and return it
  return [concat $years $months $weeks $days $hours $minutes]
}

# Make sure that the correct root path is built correctly...
proc xdcc_fixpath { } {
  global files-path xdcc_root xdcc_enable_fil_manip xdcc_croot

  set xdcc_croot ""
  set xdcc_croot $xdcc_root
  # If there is a beginning / on the croot and fil manipulation is 
  # enabled, the strip it
  if {([string index $xdcc_croot 0] == "/") && ($xdcc_enable_fil_manip)} {
    set xdcc_croot [string range $xdcc_croot 1 end]
  }
  # If the people can minipulate packets from the file sub-system, then
  # initilize the required variables.
  if {$xdcc_enable_fil_manip} {
    set xdcc_croot [file join ${files-path} $xdcc_croot]
  }
  if {[string index $xdcc_croot 0] != "/"} {
    set xdcc_croot $xdcc_croot
  }
  return 1
}

# Define a new xDCC Channel
proc xdcc_channel { cm {ch ""} {ops ""} } {
  global xdcc_channels xdcc_chanflags xdcc_defaultchanflags xdcc_chanvoicemasks xdcc_chanshortmsg
  if {[string tolower $cm] != "match"} { set ch [string tolower $ch] }
  switch -- [string tolower $cm] {
    add     {
               if {[info exists xdcc_channels($ch)]} { return 0 }
               set xdcc_channels($ch) $xdcc_defaultchanflags
               set xdcc_chanvoicemasks($ch) { }
               set xdcc_chanshortmsg($ch) ""
               set goahead 0
               for {set i 0; set flag [lindex $ops 0]} {$i < [llength $ops]} {incr i; set flag [lindex $ops $i]} {
                 if {$goahead} {incr goahead -1; continue}
                 switch -- $flag {
                   short   {
                             set xdcc_chanshortmsg($ch) [lindex $ops [expr $i + 1]]
                             incr goahead 1
                           }
                   v-masks {
                             set xdcc_chanvoicemasks($ch) [lindex $ops [expr $i + 1]]
                             incr goahead 1
                           }
                   default {
                             if {[lsearch -exact $xdcc_chanflags $flag] == -1} { continue }
                             switch -- [string index $flag 0] {
                               -        { set anti +[string range $flag 1 end] }
                               +        { set anti -[string range $flag 1 end] }
                               default  { continue                             }
                             }
                             if {[lsearch -exact $xdcc_channels($ch) $anti] != -1} {
                               set xdcc_channels($ch) [lreplace $xdcc_channels($ch) [lsearch -exact $xdcc_channels($ch) $anti] [lsearch -exact $xdcc_channels($ch) $anti]]
                             }
                               lappend xdcc_channels($ch) $flag
                             }
                 }
               }
            }

    remove  {
               if {![info exists xdcc_channels($ch)]} { return 0 }
               unset xdcc_channels($ch)
               unset xdcc_chanshortmsg($ch)
               unset xdcc_chanvoicemasks($ch)
            }

    set     {
               if {![info exists xdcc_channels($ch)]} { return 0 }
               set goahead 0
               for {set i 0; set flag [lindex $ops 0]} {$i < [llength $ops]} {incr i; set flag [lindex $ops $i]} {
                 if {$goahead} {incr goahead -1; continue}
                 switch -- $flag {
                   short   {
                             set xdcc_chanshortmsg($ch) [lindex $ops [expr $i + 1]]
                             incr goahead 1
                           }
                   v-masks {
                             set xdcc_chanvoicemasks($ch) [lindex $ops [expr $i + 1]]
                             incr goahead 1
                           }
                   default {
                             if {[lsearch -exact $xdcc_chanflags $flag] == -1} { continue }
                             switch -- [string index $flag 0] {
                               -        { set anti +[string range $flag 1 end] }
                               +        { set anti -[string range $flag 1 end] }
                               default  { continue                             }
                             }
                             if {[lsearch -exact $xdcc_channels($ch) $anti] != -1} {
                               set xdcc_channels($ch) [lreplace $xdcc_channels($ch) [lsearch -exact $xdcc_channels($ch) $anti] [lsearch -exact $xdcc_channels($ch) $anti]]
                             }
                             lappend xdcc_channels($ch) $flag
                           }
                 }
               }
            }

    info    {
               if {![info exists xdcc_channels($ch)]} { return 0 }
               return [list $xdcc_chanshortmsg($ch) $xdcc_chanvoicemasks($ch) $xdcc_channels($ch)]
            }

    is      {
               if {![info exists xdcc_channels($ch)]} { return 0 }
               switch -- $ops {
                 +short  {
                           if {$xdcc_chanshortmsg($ch) != ""} { return 1}
                         }
                 
                 -short  {
                           if {$xdcc_chanshortmsg($ch) == ""} { return 1}
                         }
                 
                 default {
                           if {[lsearch -exact $xdcc_channels($ch) $ops] == -1} { return 1 }
                         }
               }
               return 0
            }
    
    match   {
               if {$ch == ""} { return [array names xdcc_channels] }
               set r { }
               switch -- $ch {
                 +short  {
                           foreach e [array names xdcc_chanshortmsg] {
                             if {xdcc_chanshortmsg($e) != ""} {
                               lappend r $e
                             }
                           }
                         }

                 -short  {
                           foreach e [array names xdcc_chanshortmsg] {
                             if {xdcc_chanshortmsg($e) == ""} {
                               lappend r $e
                             }
                           }
                         }
 
                 default {
                           foreach e [array names xdcc_channels] {
                             if {[lsearch -exact $xdcc_channels($e) $ch] != -1} {
                               lappend r $e
                             }
                           }
                         }
               }
               return $r
            }
    default { return "" }
  }
  return $ch
}

# Offer to whomever (type, who, and whether it is short format or not)
proc xdcc_offer { t w {s 0} {m "/msg $botnick xdcc send #n"}} {
  global xdcc_packet_info xdcc_slot_num xdcc_croot xdcc_maxsend xdcc_minsend xdcc_voiced botnick xdcc_endnote

  if {$s == 0} {
    xdcc_echo $t $w "\002**\002 [llength $xdcc_packet_info] packs \002**\002"
    set count 1
    foreach packet $xdcc_packet_info {
      set files [lindex $packet 3]
      set packet_size 0
      for {set i 0} {$i < [llength $files]} {incr i} {
        if {[file exists [file join $xdcc_croot [lindex $files $i]]]} { incr packet_size [file size [file join $xdcc_croot [lindex $files $i]]] }
      }
      if {[lindex $packet 1] != ""} {
        xdcc_echo $t $w "\002#$count\002 [lindex $packet 2]x\[\002[fsize $packet_size]\002\] \[[lindex $packet 1]\] [lindex $packet 0] \[[lindex $packet 5]\]"
      } else {
        xdcc_echo $t $w "\002#$count\002 [lindex $packet 2]x\[\002[fsize $packet_size]\002\] [lindex $packet 0]"
      }
      if {[lindex $packet 4] != ""} {
        xdcc_echo $t $w " \002--->\002 [lindex $packet 4]"
      }
      incr count
    }
  } else {
    xdcc_echo $t $w "\002**\002 [llength $xdcc_packet_info] packs \002**\002 [uplevel subst {44}]"
  }
  if {$xdcc_endnote != ""} { xdcc_echo $t $w $xdcc_endnote }
  return 1
}

#######################################################################
#-------------------------- Initilization ----------------------------#
#######################################################################

# Format for the XDCC info:
# description owner get_count {file1 file2 file3 ...} comment

# Set the version
set xdcc_version 1.0

# Valid channel flags for xDCC
set xdcc_chanflags { +offer -offer +autov -autov +cycle -cycle }

# Default channel flags for xDCC
set xdcc_defaultchanflags { +offer +autov -cycle }

# Channel Voice masks
if {![array exists xdcc_chanvoicemasks]} {
  set xdcc_chanvoicemasks(*) { }
}

# Channel Short Messages
if {![array exists xdcc_chanshortmsg]} {
  set xdcc_chanshortmsg(*) ""
}

# Source in the config file
source xdcc.conf

# If this is the first time it was started, then reload packet information
if {![info exists xdcc_firsttime]} {
  xdcc_reload
}

# Rehash the script, so that new variables and stuff take hold.
xdcc_rehash

putlog "xDCC Script by Acrid_ Loaded."
