###################
# LOL's Toolz 2.0 #
###################

# ALL AMELIORATIONS, CORRECTIONS AND BUGS REPORT ARE VERY WELCOME !!!!
# IF YOU MODIFY MY SCRIPT, NO PROBLEMS, BUT MAIL ME YOUR MODIFICATIONS AND KEEP
# MY NAME AS THE ORIGINAL AUTOR.
#
#                     LOL <lol@mail.dotcom.fr>

#####################
# SHORT DESCRIPTION #
#####################

# TYPE |         COMMAND         |               DESCRIPTION               | FLAGS
# DCC    .join <#chan>             Join a new chan and set parameters.       n
# DCC    .part <#chan>             Part a chan.                              n
# DCC    .userlist [flags]         Sort the users of the bot.                n
# DCC    .security                 Security risk with dynamic IP.            m|m
# DCC    .addop <nick> <#chan> [handle] [f] Op an user in the bot.           m|m
# DCC    .delop <nick> <#chan>     Deop an user of the bot.                  m|m
# DCC    .addvoice <nick> <#chan> [handle] [f] Voice an user in the bot.     m|m
# DCC    .delvoice <nick> <#chan>     Devoice an user of the bot.            m|m
# DCC    .chanlist <#chan>         List the users of a chan.                 o|o
# DCC    .mode <#chan> <flags>     Put the requested flags at a chan.        o|o
# DCC    .help-lol                 This help.                                -
# CHAN   !banmask <mask> [time]    Ban a mask (time 0 = perm ban).           m|m
# CHAN   !ban <nick> [time]        Ban an user (time 0 = perm ban).          m|m
# CHAN   !unban <mask>             Unban a mask.                             m|m
# CHAN   !mode <flags>             Put the requested flags at a chan.        m|m
# CHAN   !addop [nick] [handle] [f] See .addop.                              m|m
# CHAN   !delop [nick]             See .delop.                               m|m
# CHAN   !addvoice [nick] [handle] [f] See .addvoice.                        m|m
# CHAN   !delvoice [nick]          See .delvoice.                            m|m
# CHAN   !op [nick]                Op an user.                               o|o
# CHAN   !deop [nick]              Deop an user.                             o|o
# CHAN   !voice [nick] [handle] [f]Voice an user.                            o|o
# CHAN   !devoice [nick]           Devoice an user.                          o|o
# CHAN   !whois <nick>             Show the satut of an user.                o|o
# CHAN   !kick <nick> [reason]     Kick an user.                             o|o
# CHAN   !quick <nick> [reason]    Kick an user and ban him 7 seconds.       o|o
# CHAN   !topic <topic>            Set a new topic.                          o|o
# CHAN   !beer [nick]              Give a fresh beer :)                      o|o
# CHAN   !coke [nick]              Give a fresh coke :)                      o|o
# CHAN   !coca-cola [nick]         Give a fresh coke :)                      o|o
# CHAN   !penalty [nick]           Shoot a penalty (french joke).            o|o
# CHAN   !seen <nickname>          Show the last time the user was online.   -
# CHAN   !help                     Help in chan.                             -
# CHAN   !time                     Show the actual time.                     -
# CHAN   !troubles                 An help to resolve the problems.          -
# MSG    banmask <pass> <mask> <#chan> [time] See !banmask.                  m|m
# MSG    addop <pass> <nick> <#chan> [handle] [f] See .addop.                m|m
# MSG    delop <pass><nick> <#chan> See .delop.                              m|m
# MSG    addvoice <pass> <nick> <#chan> [handle] [f] See .advoice.           m|m
# MSG    delvoice <pass> <nick> <#chan> See .delvoice.                       m|m
# MSG    ban <pass> <nick> <#chan> [time] See !ban.                          o|o
# MSG    unban <password> <mask> <#chan> See !unban.                         o|o
# MSG    mode <password> <#chan> <flags> See !mode.                          o|o
# MSG    whois <pass> <nick> <#chan> Show the handle of an user.             o|o

###########
# INSTALL #
###########

# Installation Instructions:
#
# In your eggdrop config file just add a line like below:
#
#     source scripts/lol.tcl
#
# And of course copy this script into the scripts directory!!
#
# Bugs Report or Comments: lol@mail.dotcom.fr
#

#########
# SETUP #
#########

# ENABLE (1) OR DISABLE (0) SECURITY WARNING. (Auto-op and help)
set security 1

# ENABLE (1) OR DISABLE (0) PASSWORD CHECKER WHEN JOIN A CHAN.
set nopass 1

# ENABLE (1) OR DISABLE (0) WELCOME MESSAGE FOR THE NON USERS OF THE BOT.
set welcome 1

# ADJUST THESES FLOOD LINES (flood accepted:number of seconds)
set chan_flood "4:15"
set join_flood "5:30"
set deop_flood "3:10"
set ctcp_flood "3:30"
set kick_flood "3:10"

# REMOVE BUG PROTECTION OF SU (for egg version 1.3.0-1.3.5)
# You can add the next lines if you  don't have egg 1.3.6 or more...
# unbind dcc - su *dcc:su
# bind dcc n su *dcc:su

# FUNCTIONS BINDS (TO REMOVE SIMPLY PLACE A # IN FRONT OF THE BIND)

bind chon m|m * chon_security
bind join -|- * join_welcome

# DANGEROUS BECAUSE PASSWORD NOT REQUESTED (TO ADD SIMPLY REMOVE THE # IN FRONT OF THE BIND)
#bind pub m|m !banmask pub_banmask
#bind pub m|m !ban pub_ban
#bind pub m|m !unban pub_unban
#bind pub m|m !mode pub_chan
#bind pub m|m !addop pub_addop
#bind pub m|m !delop pub_delop
#bind pub o|o !op pub_op
#bind pub o|o !deop pub_deop

# NORMAL (PASSWORD NOT REQUESTED BUT NOT VERY DANGEROUS FUNCTIONS)
bind pub m|m !addvoice pub_addvoice
bind pub m|m !delvoice pub_delvoice
bind pub o|o !voice pub_voice
bind pub o|o !devoice pub_devoice
bind pub o|o !kick pub_kick
bind pub o|o !quick pub_quick
bind pub o|o !topic pub_topic
bind pub o|o !whois pub_whois

# JOKE
bind pub o|o !coca-cola pub_coke
bind pub o|o !coke pub_coke
bind pub o|o !beer pub_beer
bind pub o|o !penalty pub_penalty

# UTILS
bind pub -|- !time pub_time
bind pub -|- !seen *pub:seen
bind pub -|- !help pub_help
bind pub -|- !troubles pub_troubles

# DCC (NO SECURITY RISK)
bind dcc n join dcc_join
bind dcc n part dcc_part
bind dcc n userlist dcc_userlist
bind dcc m|m security dcc_security
bind dcc m|m addop dcc_addop
bind dcc m|m delop dcc_delop
bind dcc m|m addvoice dcc_addvoice
bind dcc m|m delvoice dcc_delvoice
bind dcc o|o chanlist dcc_chanlist
bind dcc o|o mode dcc_mode
bind dcc - help dcc_help
bind dcc - help-lol dcc_help-lol

# MSG (NO SECURITY RISK PASSWORD IS REQUESTED)
bind msg m|m banmask msg_banmask
bind msg m|m addop msg_addop
bind msg m|m delop msg_delop
bind msg m|m addvoice msg_addvoice
bind msg m|m delvoice msg_delvoice
bind msg o|o ban msg_ban
bind msg o|o unban msg_unban
bind msg o|o mode msg_chan
bind msg o|o whois msg_whois
bind msg - help msg_help

################
# END OF SETUP #
################

##################################################################
### NORMALLY YOU DON'T NEED TO MODIFY ANYTHING AFTER THIS LINE ###
##################################################################

################# MISC #################

set version_lol "\002LOL's Toolz 2.0\002"

unbind pub -|- seen *pub:seen

################# START OF JOIN PROCEDURES #################

proc chon_security {handle idx} {
   global version_lol security
   if {$security != 1} { return 0 }
   putdcc $idx "\002*** WARNING !!!! ***\r"
   putdcc $idx "\002For security reasons the masters must DON'T SET THE +a FLAG (auto-op) !!!\r"
   putdcc $idx "Type \002.security\002 for more informations...\r"
   putdcc $idx "!!! Type \002.help-lol\002 to see the special commands of $version_lol !!!\r"
}

proc join_welcome {nick host hand chan} {
   global botnick welcome nopass
   if {[validuser $hand]==0} {
      if {$welcome == 1} {
         puthelp "NOTICE $nick :\037Welcome on $chan $nick !!! Type \002!help\002 for more..."
      }
   }
   if {[passwdok $hand ""]==1} {
      if {$nopass == 1} {
         puthelp "NOTICE $nick :\002You haven't still a password set !!! YOU MUST SET YOUR PASSWORD !!!"
         puthelp "NOTICE $nick :\002To set your password type: /msg $botnick pass <your_new_password>"
      }
   }
}

################# END OF JOIN PROCEDURES #################

################# START OF CHAN COMMANDS #################

### !BANMASK <mask> [time]

proc pub_banmask {nick host hand chan arg} {
   set mask [lindex $arg 0]
   set ti [lindex $arg 1]
   if {$mask == ""} {
      puthelp "NOTICE $nick :\002Usage\002: !banmask <mask> \[time\]"
      return 0
   }
   if {$ti == ""} {
      newchanban $chan $mask $nick requested
      putserv "MODE $chan +b $mask"
      return 1
   }
   newchanban $chan $mask $nick requested $ti
   putserv "MODE $chan +b $mask"
   return 1
}

### !BAN <nick> [time]

proc pub_ban {nick uhost hand chan arg} {
   global botnick
   if {$arg == ""} {
      puthelp "NOTICE $nick :\002Usage:\002 !ban <nick> \[time\]"
      return 0
   }
   set who [lindex $arg 0]
   set ti [lindex $arg 1]
   set who2 [strlwr $who]
   set botnick2 [strlwr $botnick]
   set target [nick2hand $who2 $chan]
   if {[onchan $who $chan] != 1} {
      puthelp "NOTICE $nick :I don't find $who."
      return 0
   }
   if {$who2 == $botnick2} {
      puthelp "NOTICE $nick :Yeah right, like I'm going to let you ban ME!"
      return 0
   }
   if {$target != "*"} {
      if {$hand != $target} {
         if {(([matchattr $target m|m $chan] || [matchattr $target b]) && [matchattr $hand m|m $chan] == 0)} {
            puthelp "NOTICE $nick :Sorry, you must be a master to ban a master or a bot."
            return 0
         }
      }
   }
   append banmask * "!" [getchanhost $who $chan]
   if {$ti == ""} {
      newchanban $chan $banmask $nick requested
      putserv "MODE $chan +b $banmask"
      return 1
   }
   newchanban $chan $banmask $nick requested $ti
   putserv "MODE $chan +b $banmask"
   return 1
}

### !UNBAN <mask>

proc pub_unban {nick uhost hand chan arg} {
   if {$arg == ""} {
      puthelp "NOTICE $nick :\002Usage:\002 !unban <mask>"
      return 0
   }
   killchanban $chan $arg
   putserv "MODE $chan -b $arg"
   return 1
}

### !MODE <flags>

proc pub_chan {nick uhost hand chan arg} {
   if {$arg == ""} {
      puthelp "NOTICE $nick :\002Usage:\002 !mode <flags>"
      return 0
   }
   putserv "MODE $chan $arg"
   return 1
}

### !ADDOP <nick> [handle] [f]

proc pub_addop {a b c chan e} {
   global botnick
   set nick [strlwr [lindex $e 0]]
   set res [lindex $e 1]
   set f [lindex $e 2]
   set bot [strlwr $botnick]
   set hostmask "$nick![getchanhost $nick $chan]"
   set hand [nick2hand $nick $chan]
   if {$nick == ""} {
      puthelp "NOTICE $a :\002Usage:\002 !addop <nick> \[handle\] \[f\]"
      return 0
   }
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Sorry, but i can't addop myself."
      return 0
   }
   if {$f == "f"} {
      if {[validuser $res] == 0} {
         adduser $res [maskhost $hostmask]
         chattr $res +p|+o $chan
         puthelp "NOTICE $a :New user: $res"
         puthelp "NOTICE $a :$nick added in $chan oplist and party-line with the handle: $res."
         puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $a with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
         putserv "MODE $chan +o $nick"
         return 1
      }
      setuser $res HOSTS [maskhost $hostmask]
      chattr $res --|+o $chan
      puthelp "NOTICE $a :Added hostmask for $res: [maskhost $hostmask]"
      puthelp "NOTICE $a :$nick added in $chan oplist with the handle: $res."
      puthelp "NOTICE $nick :You have been added in $chan oplist by $a with the handle: $res."
      putserv "MODE $chan +o $nick"
      return 1
   }
   if {[validuser $hand] == 0} {
      if {([validuser $nick] == 1 && $res == "")} {
         puthelp "NOTICE $a :The handle $nick already exist. \002Use:\002 !addop <nick> \[handle\] \[f\]"
         return 0
      }
      if {$res != ""} {
         if {[validuser $res] == 1} {
            puthelp "NOTICE $a :The handle $res already exist. Choose an other. \002Use:\002 !addop <nick> \[handle\] \[f\]"
            return 0
         }
         adduser $res [maskhost $hostmask]
         chattr $res +p|+o $chan
         puthelp "NOTICE $a :New user: $res"
         puthelp "NOTICE $a :$nick added in $chan oplist and party-line with the handle: $res."
         puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $a with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
         putserv "MODE $chan +o $nick"
         return 1
      }
      adduser $nick [maskhost $hostmask]
      chattr $nick +p|+o $chan
      puthelp "NOTICE $a :New user: $nick"
      puthelp "NOTICE $a :$nick added in $chan oplist and party-line with the handle: $nick."
      puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $a with the handle: $nick."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
      putserv "MODE $chan +o $nick"
      return 1
   }
   if { $res != "" } {
      if {[validuser $res] == 1} {
         puthelp "NOTICE $a :The handle $res already exist. \002Use:\002 !addop <nick> \[handle\] \[f\]"
         return 0
      }
      adduser $res [maskhost $hostmask]
      chattr $res +p|+o $chan
      puthelp "NOTICE $a :New user: $res"
      puthelp "NOTICE $a :$nick added in $chan oplist and party-line with the handle: $res."
      puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $a with the handle: $res."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
      putserv "MODE $chan +o $nick"
      return 1
   }
   if {[matchattr $hand -|+o $chan] == 1} {
      puthelp "NOTICE $a :$nick is already op in $chan with this handle: $hand"
   } else {
      chattr $hand --|+o $chan
      puthelp "NOTICE $a :$nick added in $chan oplist with this handle: $hand."
      puthelp "NOTICE $nick :You have been added in $chan oplist by $a with the handle: $hand."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan +o $nick"
      return 1
   }
   puthelp "NOTICE $a :Sorry, but i can't op $nick because i'm not op in $chan !!!"
   return 0
}

### !DELOP <nick>

proc pub_delop {a b c chan e} {
   global botnick
   set nick [strlwr [lindex $e 0]]
   set bot [strlwr $botnick]
   set hand [nick2hand $nick $chan]
   if {$nick == ""} {
      puthelp "NOTICE $a :\002Usage:\002 !delop <nick>"
      return 0
   }
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Yeah right, like I'm going to let you delop ME!"
      return 0
   }
   if {[validuser $hand] == 0} {
      puthelp "NOTICE $a :$nick is not a registered user."
      putserv "MODE $chan -o $nick"
      return 1
   }
   if {[matchattr $hand -|+o $chan] == 0} {
      puthelp "NOTICE $a :$nick is not op in $chan"
   } else {
      chattr $hand --|-o $chan
      puthelp "NOTICE $a :$nick has been removed of $chan oplist."
      puthelp "NOTICE $nick :You have been removed of $chan oplist by $a."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan -o $nick"
      return 1
   }
   puthelp "NOTICE $a :Sorry, but i can't deop $nick because i'm not op in $chan !!!"
   return 0
}

### !OP [nick]

proc pub_op {a b c chan e} {
   global botnick
   set nick [strlwr [lindex $e 0]]
   set res [lindex $e 1]
   set f [lindex $e 2]
   set bot [strlwr $botnick]
   set hostmask "$nick![getchanhost $nick $chan]"
   set hand [nick2hand $nick $chan]
   if {$nick == ""} {
      putserv "MODE $chan +o $a"
      return 1
   }
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $nick :Sorry, but i can't op myself."
      return 0
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan -v $nick"
      return 1
   }
   puthelp "NOTICE $a :Sorry, but i can't op $nick because i'm not op in $chan !!!"
   return 0
}

### !DEOP [nick]

proc pub_deop {a b c chan e} {
   global botnick
   set nick [strlwr [lindex $e 0]]
   set bot [strlwr $botnick]
   set hand [nick2hand $nick $chan]
   if {$nick == ""} {
      putserv "MODE $chan -o $a"
      return 1
   }
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Yeah right, like I'm going to let you deop ME!"
      return 0
   }
   if {$hand != "*"} {
      if {$c != $hand} {
         if {(([matchattr $hand m|m $chan] || [matchattr $hand b]) && [matchattr $c m|m $chan] == 0)} {
            puthelp "NOTICE $a :Sorry, you must be a master to deop a master or a bot."
            return 0
         }
      }
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan -o $nick"
      return 1
   }
   puthelp "NOTICE $a :Sorry, but i can't deop $nick because i'm not op in $chan !!!"
   return 0
}

### !ADDVOICE <nick> [handle] [f]

proc pub_addvoice {a b c chan e} {
   global botnick
   set nick [strlwr [lindex $e 0]]
   set res [lindex $e 1]
   set f [lindex $e 2]
   set bot [strlwr $botnick]
   set hostmask "$nick![getchanhost $nick $chan]"
   set hand [nick2hand $nick $chan]
   if {$nick == ""} {
      puthelp "NOTICE $a :\002Usage:\002 !addvoice <nick> \[handle\] \[f\]"
      return 0
   }
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Sorry, but i can't addvoice myself."
      return 0
   }
   if {$f == "f"} {
      if {[validuser $res] == 0} {
         adduser $res [maskhost $hostmask]
         chattr $res +p|+v $chan
         puthelp "NOTICE $a :New user: $res"
         puthelp "NOTICE $a :$nick added in $chan voicelist and party-line with the handle: $res."
         puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $a with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
         putserv "MODE $chan +v $nick"
         return 1
      }
      setuser $res HOSTS [maskhost $hostmask]
      chattr $res --|+v $chan
      puthelp "NOTICE $a :Added hostmask for $res: [maskhost $hostmask]"
      puthelp "NOTICE $a :$nick added in $chan voicelist with the handle: $res."
      puthelp "NOTICE $nick :You have been added in $chan voicelist by $a with the handle: $res."
      putserv "MODE $chan +v $nick"
      return 1
   }
   if {[validuser $hand] == 0} {
      if {[validuser $nick] == 1 && $res == ""} {
         puthelp "NOTICE $a :The handle $nick already exist. \002Use:\002 !addvoice <nick> \[handle\] \[f\]"
         return 0
      }
      if {$res != ""} {
         if {[validuser $res] == 1} {
            puthelp "NOTICE $a :The handle $res already exist. Choose an other. \002Use:\002 !addvoice <nick> \[handle\] \[f\]"
            return 0
         }
         adduser $res [maskhost $hostmask]
         chattr $res +p|+v $chan
         puthelp "NOTICE $a :New user: $res"
         puthelp "NOTICE $a :$nick added in $chan voicelist and party-line with the handle: $res."
         puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $a with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
         putserv "MODE $chan +v $nick"
         return 1
      }
      adduser $nick [maskhost $hostmask]
      chattr $nick +p|+v $chan
      puthelp "NOTICE $a :New user: $nick"
      puthelp "NOTICE $a :$nick added in $chan voicelist and party-line with the handle: $nick."
      puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $a with the handle: $nick."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
      putserv "MODE $chan +v $nick"
      return 1
   }
   if { $res != "" } {
      if {[validuser $res] == 1} {
         puthelp "NOTICE $a :The handle $res already exist. \002Use:\002 !addvoice <nick> \[handle\] \[f\]"
         return 0
      }
      adduser $res [maskhost $hostmask]
      chattr $res +p|+v $chan
      puthelp "NOTICE $a :New user: $res"
      puthelp "NOTICE $a :$nick added in $chan voicelist and party-line with the handle: $res."
      puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $a with the handle: $res."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
      putserv "MODE $chan +v $nick"
      return 1
   }
   if {[matchattr $hand -|+v $chan] == 1} {
      puthelp "NOTICE $a :$nick is already voice in $chan with this handle: $hand"
   } else {
      chattr $hand --|+v $chan
      puthelp "NOTICE $a :$nick added in $chan voicelist with this handle: $hand."
      puthelp "NOTICE $nick :You have been added in $chan voicelist by $a with the handle: $hand."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan +v $nick"
      return 1
   }
   puthelp "NOTICE $a :Sorry, but i can't voice $nick because i'm not op in $chan !!!"
   return 0
}

### !DELVOICE <nick>

proc pub_delvoice {a b c chan e} {
   global botnick
   set nick [strlwr [lindex $e 0]]
   set bot [strlwr $botnick]
   set hand [nick2hand $nick $chan]
   if {$nick == ""} {
      puthelp "NOTICE $a :\002Usage:\002 !delvoice <nick>"
      return 0
   }
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Yeah right, like I'm going to let you delvoice ME!"
      return 0
   }
   if {[validuser $hand] == 0} {
      puthelp "NOTICE $a :$nick is not a registered user."
      putserv "MODE $chan -v $nick"
      return 1
   }
   if {[matchattr $hand -|+v $chan] == 0} {
      puthelp "NOTICE $a :$nick is not voice in $chan"
   } else {
      chattr $hand --|-v $chan
      puthelp "NOTICE $a :$nick has been removed of $chan voicelist."
      puthelp "NOTICE $nick :You have been removed of $chan voicelist by $a."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan -v $nick"
      return 1
   }
   puthelp "NOTICE $a :Sorry, but i can't devoice $nick because i'm not op in $chan !!!"
   return 0
}

### !VOICE [nick]

proc pub_voice {a b c chan e} {
   global botnick
   set nick [strlwr [lindex $e 0]]
   set res [lindex $e 1]
   set f [lindex $e 2]
   set bot [strlwr $botnick]
   set hostmask "$nick![getchanhost $nick $chan]"
   set hand [nick2hand $nick $chan]
   if {$nick == ""} {
      putserv "MODE $chan +v $a"
      return 1
   }
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $nick :Sorry, but i can't voice myself."
      return 0
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan +v $nick"
      return 1
   }
   puthelp "NOTICE $a :Sorry, but i can't voice $nick because i'm not op in $chan !!!"
   return 0
}

### !DEVOICE [nick]

proc pub_devoice {a b c chan e} {
   global botnick
   set nick [strlwr [lindex $e 0]]
   set bot [strlwr $botnick]
   set hand [nick2hand $nick $chan]
   if {$nick == ""} {
      putserv "MODE $chan -v $a"
      return 1
   }
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Yeah right, like I'm going to let you devoice ME!"
      return 0
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan -v $nick"
      return 1
   }
   puthelp "NOTICE $a :Sorry, but i can't devoice $nick because i'm not op in $chan !!!"
   return 0
}

### !KICK <nick> [reason]

proc pub_kick {nick uhost hand chan arg} {
   global botnick
   if {$arg == ""} {
      puthelp "NOTICE $nick :\002Usage:\002 !kick <nick> \[reason\]"
      return 0
   }
   set who [lindex $arg 0]
   set who2 [strlwr $who]
   set botnick2 [strlwr $botnick]
   set reason [lrange $arg 1 end]
   set target [nick2hand $who2 $chan]
   if {[onchan $who $chan] != 1} {
      puthelp "NOTICE $nick :Sorry, but i don't find $who in $chan."
      return 0
   }
   if {$who2 == $botnick2} {
      puthelp "NOTICE $nick :Yeah right, like I'm going to let you kick ME!"
      return 0
   }
   if {$target != "*"} {
      if {$hand != $target} {
         if {(([matchattr $target m|m $chan] || [matchattr $target b]) && [matchattr $hand m|m $chan] == 0)} {
            puthelp "NOTICE $nick :Sorry, you must be a master to kick a master or a bot."
            return 0
         }
      }
   }
   if {$reason == ""} { set reason "requested" }
   putserv "KICK $chan $who :$nick: $reason"
   return 1
}

### !QUICK <nick> [reason]

proc pub_quick {nick uhost hand chan arg} {
   global botnick
   if {$arg == ""} {
      puthelp "NOTICE $nick :\002Usage:\002 !kick <nick> \[reason\]"
      return 0
   }
   set who [lindex $arg 0]
   set who2 [strlwr $who]
   set botnick2 [strlwr $botnick]
   set reason [lrange $arg 1 end]
   set target [nick2hand $who2 $chan]
   set hostmask "*![getchanhost $who $chan]"
   if {[onchan $who $chan] != 1} {
      puthelp "NOTICE $nick :Sorry, but i don't find $who in $chan."
      return 0
   }
   if {$who2 == $botnick2} {
      puthelp "NOTICE $nick :Yeah right, like I'm going to let you kick ME!"
      return 0
   }
   if {$target != "*"} {
      if {$hand != $target} {
         if {(([matchattr $target m|m $chan] || [matchattr $target b]) && [matchattr $hand m|m $chan] == 0)} {
            puthelp "NOTICE $nick :Sorry, you must be a master to quick a master or a bot."
            return 0
         }
      }
   }
   if {$reason == ""} { set reason "requested" }
   putserv "MODE $chan +b $hostmask"
   putserv "KICK $chan $who :$nick: $reason"
   utimer 7 "deban $chan $hostmask"
   return 1
}

proc deban {chan hostmask} {
   putserv "MODE $chan -b $hostmask"
}

### !TOPIC <topic>

proc pub_topic {a b c d e} {
   if {$e == ""} {
      puthelp "NOTICE $a :\002Usage\002: !topic <topic>"
      return 0
   }
   puthelp "TOPIC $d :$e"
   return 1
}

### !WHOIS <nick>

proc pub_whois {a b c d e} {
   if {$e == ""} {
      puthelp "NOTICE $a :\002Usage:\002 !whois <nick>"
      return 0
   }
   set who [lindex $e 0]
   set handle [nick2hand $who $d]
   if {$handle != "*"} {
      if {$handle != ""} {
         puthelp "NOTICE $a :The handle of $who is $handle"
         return 1
      } else {
         puthelp "NOTICE $a :I don't find $who."
         return 0
      }
   }
   if {$handle == "*"} {
      puthelp "NOTICE $a :$who is not registered in the bot"
      return 1
   }
}

### BOT JOKES ;)

proc pub_coke {nick uhost hand chan arg} {
   global botnick
   if {$arg !=""} {
      puthelp "NOTICE $chan :I offer a fresh bottle of Coca-Cola at $arg, enjoy !!!"
      return 1
   }
   puthelp "NOTICE $chan :I offer a fresh bottle of Coca-Cola at $nick, enjoy !!!"
   return 1
}

proc pub_beer {nick uhost hand chan arg} {
   global botnick
   if {$arg !=""} {
      puthelp "NOTICE $chan :I offer a fresh bottle of Beer at $arg, enjoy !!!"
      return 1
   }
   puthelp "NOTICE $chan :I offer a fresh bottle of Beer at $nick, enjoy !!!"
   return 1
}

proc pub_penalty {nick uhost hand chan arg} {
   global botnick
   set results {
      {!!! GGGOOOOOOOOOAAAAAAAAAAAAAAAAAAALLLLLLLLLLLLL !!!!!!!!! dans la lucarne gauche :))))}
      {!!! GGGOOOOOOOOOAAAAAAAAAAAAAAAAAAALLLLLLLLLLLLL !!!!!!!!! dans la lucarne droite :))))}
      {!!! GGGOOOOOOOOOAAAAAAAAAAAAAAAAAAALLLLLLLLLLLLL !!!!!!!!! en plein centre :))))}
      {!!! GGGOOOOOOOOOAAAAAAAAAAAAAAAAAAALLLLLLLLLLLLL !!!!!!!!! en force a gauche, le gardien a frol le ballon :))))}
      {!!! GGGOOOOOOOOOAAAAAAAAAAAAAAAAAAALLLLLLLLLLLLL !!!!!!!!! en force a droite, le gardien a frol le ballon :))))}
      {!!! GGGOOOOOOOOOAAAAAAAAAAAAAAAAAAALLLLLLLLLLLLL !!!!!!!!! en finnesse a gauche, le gardien pris a contre-pied :))))}
      {!!! GGGOOOOOOOOOAAAAAAAAAAAAAAAAAAALLLLLLLLLLLLL !!!!!!!!! en finnesse a droite, le gardien pris a contre-pied :))))}
      {AHHHHHHRGGGGG :(( Par dessus la transversale !!!!}
      {OOOOOOOHHUUUUUU :(((( Plein poteau :(}
      {PUUTTTTTAAAIIINNNN !!! Il a tir a cot !!!}
      {Salopard de gardien !!! :((( Il a plong du bon cot :((}
   }
   if {$arg !=""} {
      puthelp "NOTICE $chan :$arg doit a tout prix marquer le penalty pour sauver son quipe..."
      puthelp "NOTICE $chan :$arg S'ELANCE SUR LA BALLE ET IL SHOOOT !!!!!!!"
      puthelp "NOTICE $chan :[lindex $results [rand [llength $results]]]"
      return 1
   }
   puthelp "NOTICE $chan :$nick doit a tout prix marquer le penalty pour sauver son quipe..."
   puthelp "NOTICE $chan :$nick S'ELANCE SUR LA BALLE ET IL SHOOOT !!!!!!!"
   puthelp "NOTICE $chan :[lindex $results [rand [llength $results]]]"
   return 1
}

### !TIME

proc pub_time {a b c d e} {
   puthelp "NOTICE $a :We are the [date], and it's [time] !"
   return 1
}

### !HELP

proc pub_help {a b c d e} {
   global botnick version_lol
   puthelp "NOTICE $a :\037*** $version_lol CHAN HELP ***"
   if {[validuser $c]==1} {
      puthelp "NOTICE $a :Hello $a, you seems to be a registered user."
      puthelp "NOTICE $a :To get a list of bot commands type:"
      puthelp "NOTICE $a :/MSG $botnick HELP"
   }
   if {[validuser $c]==0} {
      puthelp "NOTICE $a :Hello $a, my name is $botnick, and I'm an eggdrop bot."
      puthelp "NOTICE $a :You don't seem to be a registered user."
   }
   puthelp "NOTICE $a :Here are the special channel commands of $version_lol:"
   if {[matchattr $c m|m $d]==1} {
      puthelp "NOTICE $a :Type \002!banmask <mask> \[time\]\002 to ban a mask (time 0 = perm ban)."
      puthelp "NOTICE $a :Type \002!ban <nickname> \[time\]\002 to ban someone (time 0 = perm ban)."
      puthelp "NOTICE $a :Type \002!unban <mask>\002 to unban a mask."
      puthelp "NOTICE $a :Type \002!mode <flags>\002 to put the requested flags."
      puthelp "NOTICE $a :Type \002!addop \[nick\] \[handle\] \[f\]\002 to op an user in the bot."
      puthelp "NOTICE $a :Type \002!delop \[nick\]\002 to deop an user of the bot."
      puthelp "NOTICE $a :Type \002!addvoice \[nick\] \[handle\] \[f\]\002 to voice an user in the bot."
      puthelp "NOTICE $a :Type \002!delvoice \[nick\]\002 to devoice an user of the bot."
   }
   if {[matchattr $c o|o $d]==1} {
      puthelp "NOTICE $a :Type \002!op \[nick\]\002 to op."
      puthelp "NOTICE $a :Type \002!deop \[nick\]\002 to deop."
      puthelp "NOTICE $a :Type \002!voice \[nick\]\002 to voice."
      puthelp "NOTICE $a :Type \002!devoice \[nick\]\002 to devoice."
      puthelp "NOTICE $a :Type \002!topic <topic>\002 to change topic."
      puthelp "NOTICE $a :Type \002!kick <nickname> \[reason\]\002 to kick someone."
      puthelp "NOTICE $a :Type \002!quick <nickname> \[reason\]\002 to kick someone and ban him 7 seconds."
      puthelp "NOTICE $a :Type \002!whois <nickname>\002 to see the handle of the user."
      puthelp "NOTICE $a :Type \002!coke \[nickname\]\002 to give a fresh coke :)"
      puthelp "NOTICE $a :Type \002!coca-cola \[nickname\]\002 to give a fresh coke :)"
      puthelp "NOTICE $a :Type \002!beer \[nickname\]\002 to give a fresh beer :)"
   }
   puthelp "NOTICE $a :Type \002!time\002 to get time."
   puthelp "NOTICE $a :Type \002!seen <nickname>\002 to view when an user was last on irc."
   puthelp "NOTICE $a :Type \002!troubles\002 is you have problems with me."
   puthelp "NOTICE $a :If you want more help on eggdrop's try this very good FAQ of aXs:"
   puthelp "NOTICE $a :http://mons.wpartners.com/Faq/botfaq.htm"
   puthelp "NOTICE $a :For troubles with my scripts or bugs report: \002lol@mail.dotcom.fr\002"
   return 1
}

### !TROUBLES

proc pub_troubles {a b c d e} {
   global botnick version_lol
   puthelp "NOTICE $a :\037*** $version_lol TROUBLES ***"
   puthelp "NOTICE $a :\002*** 1_You are a registered user but the bot don't recognize you: ***"
   puthelp "NOTICE $a :You have probably changed your mail@ip_address...Try:"
   puthelp "NOTICE $a :/MSG $botnick IDENT <password> <nickname>"
   puthelp "NOTICE $a :Use the <nickname> that you had, when you register in the bot. Please, don't change no more your addresse !"
   puthelp "NOTICE $a :\002*** 2_The bot don't auto-op you: ***"
   puthelp "NOTICE $a :This bot hasn't auto-op activated, to get op type:"
   puthelp "NOTICE $a :/MSG $botnick OP <password> \[#chan\]"
   puthelp "NOTICE $a :\002*** 3_The bot recognize you, but don't answer at the DCC CHAT: ***"
   puthelp "NOTICE $a :You haven't DCC CHAT rights / You are using Mirc and it don't always use standard DCC CHAT, try:"
   puthelp "NOTICE $a :/CTCP $botnick CHAT"
   puthelp "NOTICE $a :If that don't work change your DCC CHAT config or change your script."
   puthelp "NOTICE $a :\002*** If you have others problems with the script mail me: lol@mail.dotcom.fr ***"
   return 1
}

################# END OF CHAN COMMANDS #################

################# START OF DCC COMMANDS #################

### .join <#chan>

proc dcc_join {han idx arg} {
   global chan_flood deop_flood kick_flood join_flood ctcp_flood
   set chan [lindex $arg 0]
   if {$chan == ""} {
      putdcc $idx "\002Usage:\002 .join <#chan>\r"
      return 0
   }
   putlog "I'm joining $chan."
   channel add $chan
   channel set $chan chanmode "+nt"
   channel set $chan flood-chan $chan_flood
   channel set $chan flood-deop $deop_flood
   channel set $chan flood-kick $kick_flood
   channel set $chan flood-join $join_flood
   channel set $chan flood-ctcp $ctcp_flood
   channel set $chan -clearbans +enforcebans +dynamicbans +userbans -autoop -bitch -greet +protectops -statuslog +stopnethack -revenge +autovoice -secret +shared
   putlog "$chan is now configured."
}

### .part <#chan>

proc dcc_part {han idx arg} {
   set chan [lindex $arg 0]
   if {$chan == ""} {
      putdcc $idx "\002Usage:\002 .part <#chan>\r"
      return 0
   }
   putlog "I'm parting $chan"
   channel remove $chan
}

### .userlist [flags]

proc dcc_userlist {a b c} {
   set param [lindex $c 0]
   set list [userlist $param]
   putdcc $b $list
}

### .security

proc dcc_security {a b c} {
   global version_lol
   putdcc $b "                 \002********************************************\r"
   putdcc $b "                 \002*** SECURITY RISK WITH DYNAMIC IP by LOL ***\r"
   putdcc $b "                 \002********************************************\r"
   putdcc $b "\r"
   putdcc $b "Auto-op is dangerous because the majority of people hasn't a fix IP, but a\r"
   putdcc $b "dynamic IP that change each connections. When the bot takes the mask value\r"
   putdcc $b "for recognize you it use some wildcards (*). For example Bill is identified\r"
   putdcc $b "on the net like that:\r"
   putdcc $b "\r"
   putdcc $b "                 |  nick  | |  user  | |  ip addresse  |\r"
   putdcc $b "  Complete mask:    bill   !  bgates  @  195.135.14.28\r"
   putdcc $b "\r"
   putdcc $b "But the bot can't imagine that bill has a fixe IP addresse and it want recognize\r"
   putdcc $b "bill even if he has a different one. So it decides to recognize bill with that:\r"
   putdcc $b "\r"
   putdcc $b "                 |  nick  | |  user  | |  ip addresse  |\r"
   putdcc $b "  Partial mask:      *     !  bgates  @  195.135.14.*\r"
   putdcc $b "\r"
   putdcc $b "What about that ? The user part is not secure at all, all the user can take a\r"
   putdcc $b "same user value. And the IP ? 195.135.14.* ? What about that ? You can now\r"
   putdcc $b "understand that all the users with an IP beginning with 195.135.14 can make\r"
   putdcc $b "believe at the bot that they are bill....\r"
   putdcc $b " "
   putdcc $b "In this case, all the commands that bill used without password can be used by\r"
   putdcc $b "the hackers too. If bill used !op !ban !kick command in a chan, you can use\r"
   putdcc $b "them without problems.\r"
   putdcc $b "\r"
   putdcc $b "But now you know where the security hole is, you can change that....You know\r"
   putdcc $b "that bill has a fix IP, you decide to said at the bot to use the complete IP of\r"
   putdcc $b "bill to recognize him.\r"
   putdcc $b "\r"
   putdcc $b ".-host bill *!bgates@195.135.14.*\r"
   putdcc $b ".+host bill *!*@195.135.14.28\r"
   putdcc $b "\r"
   putdcc $b "Now it's ok for bill, no hackers can take his place, but what's about users\r"
   putdcc $b "without a fix ip ? For them you are obligated to use * in IP, so you are never\r"
   putdcc $b "sure that an hacker can't take their places... Is for that, that the !op,\r"
   putdcc $b "!banmask commands are dangerous, because if an hacker can take a mask that\r"
   putdcc $b "match with the user mask, he can use theses commands like them.\r"
   putdcc $b "\r"
   putdcc $b "Now back to auto-op :) It's exactly the same problem...So if an user has a fix\r"
   putdcc $b "IP address, you must check that the bot has take the complete addresse, and then\r"
   putdcc $b "you can put the auto-op flag, if this user hasn't a fix IP address you don't\r"
   putdcc $b "must put the +a flag (+a flag = !OP function).\r"
   putdcc $b "\r"
   putdcc $b "                                                $version_lol\r"
}

### .addop <nick> <#chan> [handle] [f]

proc dcc_addop {hand idx arg} {
   global botnick
   set nick [strlwr [lindex $arg 0]]
   set chan [strlwr [lindex $arg 1]]
   set res [lindex $arg 2]
   set f [lindex $arg 3]
   set bot [strlwr $botnick]
   if {$chan == ""} {
      putdcc $idx "\002Usage:\002 .addop <nick> <#chan> \[handle\] \[f\]\r"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      putdcc $idx "I'm not on $chan \r"
      return 0
   }
   if {[matchattr $hand m|m $chan] == 0} {
      putdcc $idx "Sorry, but you are not master in $chan."
      return 0
   }
   set hostmask "$nick![getchanhost $nick $chan]"
   set hand [nick2hand $nick $chan]
   if {[onchan $nick $chan] == 0} {
      putdcc $idx "Sorry, but i don't find $nick in $chan.\r"
      return 0
   }
   if {$nick == $bot} {
      putdcc $idx "Sorry, but i can't addop myself.\r"
      return 0
   }
   if {$f == "f"} {
      if {[validuser $res] == 0} {
         adduser $res [maskhost $hostmask]
         chattr $res +p|+o $chan
         putdcc $idx "New user: $res\r"
         putdcc $idx "$nick added in $chan oplist and party-line with the handle: $res.\r"
         puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $hand with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
         putserv "MODE $chan +o $nick"
         return 1
      }
      setuser $res HOSTS [maskhost $hostmask]
      chattr $res --|+o $chan
      putdcc $idx "Added hostmask for $res: [maskhost $hostmask]\r"
      putdcc $idx "$nick added in $chan oplist with the handle: $res.\r"
      puthelp "NOTICE $nick :You have been added in $chan oplist by $hand with the handle: $res."
      putserv "MODE $chan +o $nick"
      return 1
   }
   if {[validuser $hand] == 0} {
      if {([validuser $nick] == 1 && $res == "")} {
         putdcc $idx "The handle $nick already exist. \002Use:\002 addop <nick> <#chan> \[handle\] \[f\]\r"
         return 0
      }
      if {$res != ""} {
         if {[validuser $res] == 1} {
            putdcc $idx "The handle $res already exist. Choose an other. \002Use:\002 addop <nick> <#chan> \[handle\] \[f\]\r"
            return 0
         }
         adduser $res [maskhost $hostmask]
         chattr $res +p|+o $chan
         putdcc $idx "New user: $res\r"
         putdcc $idx "$nick added in $chan oplist and party-line with the handle: $res.\r"
         puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $hand with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
         putserv "MODE $chan +o $nick"
         return 1
      }
      adduser $nick [maskhost $hostmask]
      chattr $nick +p|+o $chan
      putdcc $idx "New user: $nick\r"
      putdcc $idx "$nick added in $chan oplist and party-line with the handle: $nick.\r"
      puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $hand with the handle: $nick."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
      putserv "MODE $chan +o $nick"
      return 1
   }
   if {$res != ""} {
      if {[validuser $res]} {
         putdcc $idx "The handle $res already exist. \002Use:\002 addop <nick> <#chan> \[handle\] \[f\]\r"
         return 0
      }
      adduser $res [maskhost $hostmask]
      chattr $res +p|+o $chan
      putdcc $idx "New user: $res\r"
      putdcc $idx "$nick added in $chan oplist and party-line with the handle: $res.\r"
      puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $hand with the handle: $res."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
      putserv "MODE $chan +o $nick"
      return 1
   }
   if {[matchattr $hand -|+o $chan] == 1} {
      putdcc $idx "$nick is already op in $chan with this handle: $hand\r"
   } else {
      chattr $hand --|+o $chan
      putdcc $idx "$nick added in $chan oplist with this handle: $hand.\r"
      puthelp "NOTICE $nick :You have been added in $chan oplist by $hand with the handle: $hand."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan +o $nick"
      return 1
   }
   putdcc $idx "Sorry, but i can't op $nick because i'm not op in $chan !!!\r"
   return 0
}

### .delop <nick> <#chan>

proc dcc_delop {hand idx arg} {
   global botnick
   set nick [strlwr [lindex $arg 0]]
   set chan [strlwr [lindex $arg 1]]
   set bot [strlwr $botnick]
   if {$chan == ""} {
      putdcc $idx "\002Usage:\002 .delop <nick> <#chan>\r"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      putdcc $idx "I'm not on $chan \r"
      return 0
   }
   if {[matchattr $hand m|m $chan] == 0} {
      putdcc $idx "Sorry, but you are not master in $chan."
      return 0
   }
   set hand [nick2hand $nick $chan]
   if {[onchan $nick $chan] == 0} {
      putdcc $idx "Sorry, but i don't find $nick in $chan.\r"
      return 0
   }
   if {$nick == $bot} {
      putdcc $idx "Yeah right, like I'm going to let you delop ME!\r"
      return 0
   }
   if {[validuser $hand] == 0} {
      putdcc $idx "$nick is not a registered user.\r"
      putserv "MODE $chan -o $nick"
      return 1
   }
   if {[matchattr $hand -|+o $chan] == 0} {
      putdcc $idx "$nick is not op in $chan\r"
   } else {
      chattr $hand --|-o $chan
      putdcc $idx "$nick has been removed of $chan oplist.\r"
      puthelp "NOTICE $nick :You have been removed of $chan oplist by $hand."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan -o $nick"
      return 1
   }
   putdcc $idx "Sorry, but i can't deop $nick because i'm not op in $chan !!!\r"
   return 0
}

### .addvoice <nick> <#chan> [handle] [f]

proc dcc_addvoice {hand idx arg} {
   global botnick
   set nick [strlwr [lindex $arg 0]]
   set chan [strlwr [lindex $arg 1]]
   set res [lindex $arg 2]
   set f [lindex $arg 3]
   set bot [strlwr $botnick]
   if {$chan == ""} {
      putdcc $idx "\002Usage:\002 .addvoice <nick> <#chan> \[handle\] \[f\]\r"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      putdcc $idx "I'm not on $chan \r"
      return 0
   }
   if {[matchattr $hand m|m $chan] == 0} {
      putdcc $idx "Sorry, but you are not master in $chan."
      return 0
   }
   set hostmask "$nick![getchanhost $nick $chan]"
   set hand [nick2hand $nick $chan]
   if {[onchan $nick $chan] == 0} {
      putdcc $idx "Sorry, but i don't find $nick in $chan.\r"
      return 0
   }
   if {$nick == $bot} {
      putdcc $idx "Sorry, but i can't addvoice myself.\r"
      return 0
   }
   if {$f == "f"} {
      if {[validuser $res] == 0} {
         adduser $res [maskhost $hostmask]
         chattr $res +p|+v $chan
         putdcc $idx "New user: $res\r"
         putdcc $idx "$nick added in $chan voicelist and party-line with the handle: $res.\r"
         puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $hand with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
         putserv "MODE $chan +v $nick"
         return 1
      }
      setuser $res HOSTS [maskhost $hostmask]
      chattr $res --|+v $chan
      putdcc $idx "Added hostmask for $res: [maskhost $hostmask]\r"
      putdcc $idx "$nick added in $chan voicelist with the handle: $res.\r"
      puthelp "NOTICE $nick :You have been added in $chan voicelist by $hand with the handle: $res."
      putserv "MODE $chan +v $nick"
      return 1
   }
   if {[validuser $hand] == 0} {
      if {([validuser $nick] == 1 && $res == "")} {
         putdcc $idx "The handle $nick already exist. \002Use:\002 .addvoice <nick> <#chan> \[handle\] \[f\]\r"
         return 0
      }
      if {$res != ""} {
         if {[validuser $res] == 1} {
            putdcc $idx "The handle $res already exist. Choose an other. \002Use:\002 !addvoice <nick> <handle> <f>\r"
            return 0
         }
         adduser $res [maskhost $hostmask]
         chattr $res +p|+v $chan
         putdcc $idx "New user: $res\r"
         putdcc $idx "$nick added in $chan voicelist and party-line with the handle: $res.\r"
         puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $hand with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
         putserv "MODE $chan +v $nick"
         return 1
      }
      adduser $nick [maskhost $hostmask]
      chattr $nick +p|+v $chan
      putdcc $idx "New user: $nick\r"
      putdcc $idx "$nick added in $chan voicelist and party-line with the handle: $nick.\r"
      puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $hand with the handle: $nick."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
      putserv "MODE $chan +v $nick"
      return 1
   }
   if { $res != "" } {
      if {[validuser $res] == 1} {
         putdcc $idx "The handle $res already exist. \002Use:\002 .addvoice <nick> <#chan> \[handle\] \[f\]\r"
         return 0
      }
      adduser $res [maskhost $hostmask]
      chattr $res +p|+v $chan
      putdcc $idx "New user: $res\r"
      putdcc $idx "$nick added in $chan voicelist and party-line with the handle: $res.\r"
      puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $hand with the handle: $res."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
      putserv "MODE $chan +v $nick"
      return 1
   }
   if {[matchattr $hand -|+v $chan] == 1} {
      putdcc $idx "$nick is already voice in $chan with this handle: $hand\r"
   } else {
      chattr $hand --|+v $chan
      putdcc $idx "$nick added in $chan voicelist with this handle: $hand.\r"
      puthelp "NOTICE $nick :You have been added in $chan voicelist by $hand with the handle: $hand."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan +v $nick"
      return 1
   }
   putdcc $idx "Sorry, but i can't voice $nick because i'm not op in $chan !!!\r"
   return 0
}

### .delvoice <nick> <#chan>

proc dcc_delvoice {hand idx arg} {
   global botnick
   set nick [strlwr [lindex $arg 0]]
   set chan [strlwr [lindex $arg 1]]
   set bot [strlwr $botnick]
   if {$chan == ""} {
      putdcc $idx "\002Usage:\002 .delvoice <nick> <#chan>\r"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      putdcc $idx "I'm not on $chan \r"
      return 0
   }
   if {[matchattr $hand m|m $chan] == 0} {
      putdcc $idx "Sorry, but you are not master in $chan."
      return 0
   }
   set hand [nick2hand $nick $chan]
   if {[onchan $nick $chan] == 0} {
      putdcc $idx "Sorry, but i don't find $nick in $chan.\r"
      return 0
   }
   if {$nick == $bot} {
      putdcc $idx "Yeah right, like I'm going to let you delvoice ME!\r"
      return 0
   }
   if {[validuser $hand] == 0} {
      putdcc $idx "$nick is not a registered user.\r"
      putserv "MODE $chan -v $nick"
      return 1
   }
   if {[matchattr $hand -|+v $chan] == 0} {
      putdcc $idx "$nick is not voice in $chan\r"
   } else {
      chattr $hand --|-v $chan
      putdcc $idx "$nick has been removed of $chan voicelist.\r"
      puthelp "NOTICE $nick :You have been removed of $chan voicelist by $hand."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan -v $nick"
      return 1
   }
   putdcc $idx "Sorry, but i can't devoice $nick because i'm not op in $chan !!!\r"
   return 0
}

### .chanlist <#chan>

proc dcc_chanlist {a b c} {
   set chan [lindex $c 0]
   if {$chan == ""} {
      putdcc $b "\002Usage:\002 .chanlist <#chan>\r"
      return 0
   }
   set v [validchan $chan]
   if {$v == 1} {
      putdcc $b "$chan is a STATIC channel\r"
      if {[matchattr $a o|o $chan] != 1} {
         putdcc $b "You are not operator of $chan.\r"
         return 0
      }
      *dcc:channel $a $b $chan
      return 0
   }
   set d [isdynamic $chan]
   if {$d == 1} {
      putdcc $b "$chan is a DYNAMIC channel\r"
      if {[matchattr $a o|o $chan] != 1} {
         putdcc $b "You are not operator of $chan.\r"
         return 0
      }
      *dcc:channel $a $b $chan
      return 0
   }
   if {[matchattr $a o|o] != 1} {
      putdcc $b "You are not operator of $chan.\r"
      return 0
   }
   putdcc $b "Joining $chan...\r"
   channel add $chan
   utimer 10 "*dcc:channel $a $b $chan"
   utimer 15 "partchan $b $chan"
}

proc partchan {b chan} {
   putdcc $b "Parting $chan...\r"
   channel remove $chan
}

### .mode <#chan> <flags>

proc dcc_mode {a b c} {
   set chan [lindex $c 0]
   set flags [lindex $c 1]
   if {$flags == ""} {
      putdcc $b "\002Usage:\002 .mode <#chan> <flags>\r"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      putdcc $b "I'm not on $chan \r"
      return 0
   }
   if {[matchchanattr $a o|o $chan]} {
      putserv "MODE $chan $flags"
      putdcc $b "Mode of $chan changed.\r"
   } else {
      putdcc $b "You are not operator of $chan.\r"
   }
}

### .help

proc dcc_help {a b c} {
   global version_lol
   *dcc:help $a $b $c
   putdcc $b "!!! Type \002.help-lol\002 to see the special commands of $version_lol !!!\r"
}

### .help-lol

proc dcc_help-lol {a b c} {
   global botnick version_lol
   putdcc $b "                          \002*****************************\r"
   putdcc $b "                          \002*** Commands of LOL Toolz ***\r"
   putdcc $b "                          \002*****************************\r"
   putdcc $b "\r"
   putdcc $b "\037TYPE |         COMMAND         |               DESCRIPTION               | FLAGS\r"
   putdcc $b "DCC    .join <#chan>             Join a new chan and set parameters.       n\r"
   putdcc $b "DCC    .part <#chan>             Part a chan.                              n\r"
   putdcc $b "DCC    .userlist \[flags\]         Sort the users of the bot.                n\r"
   putdcc $b "DCC    .security                 Security risk with dynamic IP.            m|m\r"
   putdcc $b "DCC    .addop <nick> <#chan> \[handle\] \[f\] Op an user in the bot.           m|m\r"
   putdcc $b "DCC    .delop <nick> <#chan>     Deop an user of the bot.                  m|m\r"
   putdcc $b "DCC    .addvoice <nick> <#chan> \[handle\] \[f\] Voice an user in the bot.     m|m\r"
   putdcc $b "DCC    .delvoice <nick> <#chan>  Devoice an user of the bot.               m|m\r"
   putdcc $b "DCC    .chanlist <#chan>         List the users of a chan.                 o|o\r"
   putdcc $b "DCC    .mode <#chan> <flags>     Put the requested flags at a chan.        o|o\r"
   putdcc $b "DCC    .help-lol                 This help.                                -\r"
   putdcc $b "CHAN   !banmask <mask> \[time\]    Ban a mask (time 0 = perm ban).           m|m\r"
   putdcc $b "CHAN   !ban <nick> \[time\]        Ban an user (time 0 = perm ban).          m|m\r"
   putdcc $b "CHAN   !unban <mask>             Unban a mask.                             m|m\r"
   putdcc $b "CHAN   !mode <flags>             Put the requested flags at a chan.        m|m\r"
   putdcc $b "CHAN   !addop <nick> \[handle\] \[f\] See .addop.                              m|m\r"
   putdcc $b "CHAN   !delop <nick>             See .delop.                               m|m\r"
   putdcc $b "CHAN   !addvoice <nick> \[handle\] \[f\] See .advoice.                         m|m\r"
   putdcc $b "CHAN   !delvoice <nick>          See .delvoice..                           m|m\r"
   putdcc $b "CHAN   !op \[nick\]                Op an user.                               o|o\r"
   putdcc $b "CHAN   !deop \[nick\]              Deop an user.                             o|o\r"
   putdcc $b "CHAN   !voice \[nick\]             Voice an user.                            o|o\r"
   putdcc $b "CHAN   !devoice \[nick\]           Devoice an user.                          o|o\r"
   putdcc $b "CHAN   !whois <nick>             Show the satut of an user.                o|o\r"
   putdcc $b "CHAN   !kick <nick> \[reason\]     Kick an user.                             o|o\r"
   putdcc $b "CHAN   !quick <nick> \[reason\]    Kick an user and ban him 7 seconds.       o|o\r"
   putdcc $b "CHAN   !topic <topic>            Set a new topic.                          o|o\r"
   putdcc $b "CHAN   !beer \[nick\]              Give a fresh beer :)                      o|o\r"
   putdcc $b "CHAN   !coke \[nick\]              Give a fresh coke :)                      o|o\r"
   putdcc $b "CHAN   !coca-cola \[nick\]         Give a fresh coke :)                      o|o\r"
   putdcc $b "CHAN   !penalty \[nick\]           Shoot a penalty (french joke).            o|o\r"
   putdcc $b "CHAN   !seen <nickname>          Show the last time the user was online.   -\r"
   putdcc $b "CHAN   !help                     Help in chan.                             -\r"
   putdcc $b "CHAN   !time                     Show the actual time.                     -\r"
   putdcc $b "CHAN   !troubles                 An help to resolve the problems.          -\r"
   putdcc $b "MSG    banmask <pass> <mask> <#chan> \[time\] See !banmask.                  m|m\r"
   putdcc $b "MSG    addop <pass> <nick> <#chan> \[handle\] \[f\] See .addop.                m|m\r"
   putdcc $b "MSG    delop <pass> <nick> <#chan> See .delop.                             m|m\r"
   putdcc $b "MSG    addvoice <pass> <nick> <#chan> \[handle\] \[f\] See.addvoice.           m|m\r"
   putdcc $b "MSG    delvoice <pass> <nick> <#chan> See.delvoice.                        m|m\r"
   putdcc $b "MSG    ban <pass> <nick> <#chan> \[time\] See !ban.                          o|o\r"
   putdcc $b "MSG    unban <password> <mask> <#chan> See !unban.                         o|o\r"
   putdcc $b "MSG    mode <password> <#chan> <flags> See !mode.                          o|o\r"
   putdcc $b "MSG    whois <pass> <nick> <#chan> Show the handle of an user.             o|o\r"
   putdcc $b "\r"
   putdcc $b "$version_lol\r"
   putdcc $b "Report me the bugs, thanks. \002lol@mail.dotcom.fr\002\r"
}

################# END OF DCC COMMANDS #################

################# START OF MSG COMMANDS #################

### banmask <password> <mask> <#chan> [time]

proc msg_banmask {nick host hand arg} {
   set pass [lindex $arg 0]
   set mask [lindex $arg 1]
   set chan [lindex $arg 2]
   set ti [lindex $arg 3]
   if {$chan == ""} {
      puthelp "NOTICE $nick :\002Usage\002: banmask <password> <mask> <#chan> \[time\]"
      return 0
   }
   if {[passwdok $hand $pass] == 0} {
      puthelp "NOTICE $nick :Invalid password."
      puthelp "NOTICE $nick :\002Usage:\002 banmask <password> <mask> <#chan> \[time\]"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      puthelp "NOTICE $nick :I'm not on $chan "
      return 0
   }
   if {[matchattr $hand m|m $chan] == 0} {
      puthelp "NOTICE $nick :Sorry, but you are not master in $chan."
      return 0
   }
   if {$ti == ""} {
      newchanban $chan $mask $nick requested
      putserv "MODE $chan +b $mask"
      return 0
   }
   newchanban $chan $mask $nick requested $ti
   putserv "MODE $chan +b $mask"
   return 0
}

### ban <password> <nick> <#chan> [time]

proc msg_ban {nick uhost hand arg} {
   global botnick
   set pass [lindex $arg 0]
   set chan [lindex $arg 1]
   set who [lindex $arg 2]
   set ti [lindex $arg 3]
   set who2 [strlwr $who]
   set botnick2 [strlwr $botnick]
   if {$who == ""} {
      puthelp "NOTICE $nick :\002Usage:\002 ban <password> <nick> <#chan> \[time\]"
      return 0
   }
   if {[passwdok $hand $pass] == 0} {
      puthelp "NOTICE $nick :Invalid password."
      puthelp "NOTICE $nick :\002Usage:\002 ban <password> <nick> <#chan> \[time\]"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      puthelp "NOTICE $nick :I'm not on $chan "
      return 0
   }
   if {[matchattr $hand m|m $chan] == 0} {
      puthelp "NOTICE $nick :Sorry, but you are not master in $chan."
      return 0
   }
   set target [nick2hand $who2 $chan]
   if {[onchan $who $chan] != 1} {
      puthelp "NOTICE $nick :I don't find $who."
      return 0
   }
   if {$who2 == $botnick2} {
      puthelp "NOTICE $nick :Yeah right, like I'm going to let you ban ME!"
      return 0
   }
   if {$target != "*"} {
      if {$hand != $target} {
         if {(([matchattr $target m|m $chan] || [matchattr $target b]) && [matchattr $hand m|m $chan] == 0)} {
            puthelp "NOTICE $nick :Sorry, you must be a master to ban a master or a bot."
            return 0
         }
      }
   }
   append banmask * "!" [getchanhost $who $chan]
   if {$ti == ""} {
      newchanban $chan $banmask $nick requested
      putserv "MODE $chan +b $banmask"
      return 0
   }
   newchanban $chan $banmask $nick requested $ti
   putserv "MODE $chan +b $banmask"
   return 0
}

### unban <password> <mask> <#chan>

proc msg_unban {nick uhost hand arg} {
   set pass [lindex $arg 0]
   set mask [lindex $arg 1]
   set chan [lindex $arg 2]
   if {$chan == ""} {
      puthelp "NOTICE $nick :\002Usage:\002 unban <password> <mask> <#chan>"
      return 0
   }
   if {[passwdok $hand $pass] == 0} {
      puthelp "NOTICE $nick :Invalid password."
      puthelp "NOTICE $nick :\002Usage:\002 unban <password> <mask> <#chan>"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      puthelp "NOTICE $nick :I'm not on $chan "
      return 0
   }
   if {[matchattr $hand m|m $chan] == 0} {
      puthelp "NOTICE $nick :Sorry, but you are not master in $chan."
      return 0
   }
   killchanban $chan $mask
   putserv "MODE $chan -b $mask"
   return 0
}

### mode <password> <#chan> <flags>

proc msg_chan {nick uhost hand arg} {
   set pass [lindex $arg 0]
   set chan [lindex $arg 1]
   set flags [lindex $arg 2]
   if {$flags == ""} {
      puthelp "NOTICE $nick :\002Usage:\002 mode <password> <#chan> <flags>"
      return 0
   }
   if {[passwdok $hand $pass] == 0} {
      puthelp "NOTICE $nick :Invalid password."
      puthelp "NOTICE $nick :\002Usage:\002 mode <password> <#chan> <flags>"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      puthelp "NOTICE $nick :I'm not on $chan "
      return 0
   }
   if {[matchattr $hand m|m $chan] == 0} {
      puthelp "NOTICE $nick :Sorry, but you are not master in $chan."
      return 0
   }
   putserv "MODE $chan $flags"
   return 0
}

### whois <password> <nick> <#chan>

proc msg_whois {a b c d} {
   set pass [lindex $d 0]
   set who [lindex $d 1]
   set chan [lindex $d 2]
   if {$d == ""} {
      puthelp "NOTICE $a :\002Usage:\002 whois <password> <nick> <#chan>"
      return 0
   }
   if {[passwdok $c $pass] == 0} {
      puthelp "NOTICE $a :Invalid password."
      puthelp "NOTICE $a :\002Usage:\002 whois <password> <nick> <#chan>"
      return 0
   }
   if {$chan == ""} {
      puthelp "NOTICE $a :\002Usage:\002 whois <password> <nick> <#chan>"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      puthelp "NOTICE $a :I'm not on $chan "
      return 0
   }
   if {[onchan $who $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $who in $chan."
      return 0
   }
   append userhost $who "!" [getchanhost $who $chan]
   set handle [finduser $userhost]
   if {$handle != "*"} {
      puthelp "NOTICE $a :The handle of $who is $handle"
   }
   if {$handle == "*"} {
      puthelp "NOTICE $a :$who is nor registered in the bot"
   }
}

### addop <password> <nick> <#chan> [handle] [f]

proc msg_addop {a b c arg} {
   global botnick
   set pass [lindex $arg 0]
   set nick [strlwr [lindex $arg 1]]
   set chan [strlwr [lindex $arg 2]]
   set res [lindex $arg 3]
   set f [lindex $arg 4]
   set bot [strlwr $botnick]
   if {$arg == ""} {
      puthelp "NOTICE $a :\002Usage:\002 addop <password> <nick> <#chan> \[handle\] \[f\]"
      return 0
   }
   if {[passwdok $c $pass] == 0} {
      puthelp "NOTICE $a :Invalid password."
      puthelp "NOTICE $a :\002Usage:\002 addop <password> <nick> <#chan> \[handle\] \[f\]"
      return 0
   }
   if {$chan == ""} {
      puthelp "NOTICE $a :\002Usage:\002 addop <password> <nick> <#chan> \[handle\] \[f\]"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      puthelp "NOTICE $a :I'm not on $chan "
      return 0
   }
   if {[matchattr $c m|m $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but you are not master in $chan."
      return 0
   }
   set hostmask "$nick![getchanhost $nick $chan]"
   set hand [nick2hand $nick $chan]
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Sorry, but i can't addop myself."
      return 0
   }
   if {$f == "f"} {
      if {[validuser $res] == 0} {
         adduser $res [maskhost $hostmask]
         chattr $res +p|+o $chan
         puthelp "NOTICE $a :New user: $res"
         puthelp "NOTICE $a :$nick added in $chan oplist and party-line with the handle: $res."
         puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $a with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
         putserv "MODE $chan +o $nick"
         return 0
      }
      setuser $res HOSTS [maskhost $hostmask]
      chattr $res --|+o $chan
      puthelp "NOTICE $a :Added hostmask for $res: [maskhost $hostmask]"
      puthelp "NOTICE $a :$nick added in $chan oplist with the handle: $res."
      puthelp "NOTICE $nick :You have been added in $chan oplist by $a with the handle: $res."
      putserv "MODE $chan +o $nick"
      return 0
   }
   if {[validuser $hand] == 0} {
      if {([validuser $nick] == 1 && $res == "")} {
         puthelp "NOTICE $a :The handle $nick already exist. \002Use:\002 !addop <nick> <handle> <f>"
         return 0
      }
      if {$res != ""} {
         if {[validuser $res] == 1} {
            puthelp "NOTICE $a :The handle $res already exist. Choose an other. \002Use:\002 !addop <nick> <handle> <f>"
            return 0
         }
         adduser $res [maskhost $hostmask]
         chattr $res +p|+o $chan
         puthelp "NOTICE $a :New user: $res"
         puthelp "NOTICE $a :$nick added in $chan oplist and party-line with the handle: $res."
         puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $a with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
         putserv "MODE $chan +o $nick"
         return 0
      }
      adduser $nick [maskhost $hostmask]
      chattr $nick +p|+o $chan
      puthelp "NOTICE $a :New user: $nick"
      puthelp "NOTICE $a :$nick added in $chan oplist and party-line with the handle: $nick."
      puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $a with the handle: $nick."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
      putserv "MODE $chan +o $nick"
      return 0
   }
   if {$res != ""} {
      if {[validuser $res]} {
         puthelp "NOTICE $a :The handle $res already exist. \002Use:\002 !addop <nick> <handle> <f>"
         return 0
      }
      adduser $res [maskhost $hostmask]
      chattr $res +p|+o $chan
      puthelp "NOTICE $a :New user: $res"
      puthelp "NOTICE $a :$nick added in $chan oplist and party-line with the handle: $res."
      puthelp "NOTICE $nick :You have been added in $chan oplist and party-line by $a with the handle: $res."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
      putserv "MODE $chan +o $nick"
      return 0
   }
   if {[matchattr $hand -|+o $chan] == 1} {
      puthelp "NOTICE $a :$nick is already op in $chan with this handle: $hand"
   } else {
      chattr $hand --|+o $chan
      puthelp "NOTICE $a :$nick added in $chan oplist with this handle: $hand."
      puthelp "NOTICE $nick :You have been added in $chan oplist by $a with the handle: $hand."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan +o $nick"
      return 0
   }
   puthelp "NOTICE $a :Sorry, but i can't op $nick because i'm not op in $chan !!!"
   return 0
}

### delop <password> <nick> <#chan>

proc msg_delop {a b c arg} {
   global botnick
   set pass [lindex $arg 0]
   set nick [strlwr [lindex $arg 1]]
   set chan [strlwr [lindex $arg 2]]
   set bot [strlwr $botnick]
   if {$arg == ""} {
      puthelp "NOTICE $a :\002Usage:\002 delop <password> <nick> <#chan>"
      return 0
   }
   if {[passwdok $c $pass] == 0} {
      puthelp "NOTICE $a :Invalid password."
      puthelp "NOTICE $a :\002Usage:\002 delop <password> <nick> <#chan>"
      return 0
   }
   if {$chan == ""} {
      puthelp "NOTICE $a :\002Usage:\002 delop <password> <nick> <#chan>"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      puthelp "NOTICE $a :I'm not on $chan "
      return 0
   }
   if {[matchattr $c m|m $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but you are not master in $chan."
      return 0
   }
   set hand [nick2hand $nick $chan]
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Yeah right, like I'm going to let you delop ME!"
      return 0
   }
   if {[validuser $hand] == 0} {
      puthelp "NOTICE $a :$nick is not a registered user."
      putserv "MODE $chan -o $nick"
      return 0
   }
   if {[matchattr $hand -|+o $chan] == 0} {
      puthelp "NOTICE $a :$nick is not op in $chan"
   } else {
      chattr $hand --|-o $chan
      puthelp "NOTICE $a :$nick has been removed of $chan oplist."
      puthelp "NOTICE $nick :You have been removed of $chan oplist by $a."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan -o $nick"
      return 0
   }
   puthelp "NOTICE $a :Sorry, but i can't deop $nick because i'm not op in $chan !!!"
   return 0
}

### addvoice <password> <nick> <#chan> [handle] [f]

proc msg_addvoice {a b c arg} {
   global botnick
   set pass [lindex $arg 0]
   set nick [strlwr [lindex $arg 1]]
   set chan [strlwr [lindex $arg 2]]
   set res [lindex $arg 3]
   set f [lindex $arg 4]
   set bot [strlwr $botnick]
   if {$arg == ""} {
      puthelp "NOTICE $a :\002Usage:\002 addvoice <password> <nick> <#chan> \[handle\] \[f\]"
      return 0
   }
   if {[passwdok $c $pass] == 0} {
      puthelp "NOTICE $a :Invalid password."
      puthelp "NOTICE $a :\002Usage:\002 addvoice <password> <nick> <#chan> \[handle\] \[f\]"
      return 0
   }
   if {$chan == ""} {
      puthelp "NOTICE $a :\002Usage:\002 addvoice <password> <nick> <#chan> \[handle\] \[f\]"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      puthelp "NOTICE $a :I'm not on $chan "
      return 0
   }
   if {[matchattr $c m|m $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but you are not master in $chan."
      return 0
   }
   set hostmask "$nick![getchanhost $nick $chan]"
   set hand [nick2hand $nick $chan]
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Sorry, but i can't addvoice myself."
      return 0
   }
   if {$f == "f"} {
      if {[validuser $res] == 0} {
         adduser $res [maskhost $hostmask]
         chattr $res +p|+v $chan
         puthelp "NOTICE $a :New user: $res"
         puthelp "NOTICE $a :$nick added in $chan voicelist and party-line with the handle: $res."
         puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $a with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
         putserv "MODE $chan +v $nick"
         return 0
      }
      setuser $res HOSTS [maskhost $hostmask]
      chattr $res --|+v $chan
      puthelp "NOTICE $a :Added hostmask for $res: [maskhost $hostmask]"
      puthelp "NOTICE $a :$nick added in $chan voicelist with the handle: $res."
      puthelp "NOTICE $nick :You have been added in $chan voicelist by $a with the handle: $res."
      putserv "MODE $chan +v $nick"
      return 0
   }
   if {[validuser $hand] == 0} {
      if {([validuser $nick] == 1 && $res == "")} {
         puthelp "NOTICE $a :The handle $nick already exist. \002Use:\002 !addvoice <nick> <handle> <f>"
         return 0
      }
      if {$res != ""} {
         if {$res != ""} {
            puthelp "NOTICE $a :The handle $res already exist. Choose an other. \002Use:\002 !addvoice <nick> <handle> <f>"
            return 0
         }
         adduser $res [maskhost $hostmask]
         chattr $res +p|+v $chan
         puthelp "NOTICE $a :New user: $res"
         puthelp "NOTICE $a :$nick added in $chan voicelist and party-line with the handle: $res."
         puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $a with the handle: $res."
         puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
         putserv "MODE $chan +v $nick"
         return 0
      }
      adduser $nick [maskhost $hostmask]
      chattr $nick +p|+v $chan
      puthelp "NOTICE $a :New user: $nick"
      puthelp "NOTICE $a :$nick added in $chan voicelist and party-line with the handle: $nick."
      puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $a with the handle: $nick."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick pass <your_password>\002"
      putserv "MODE $chan +v $nick"
      return 0
   }
   if { $res != "" } {
      if {[validuser $res] == 1} {
         puthelp "NOTICE $a :The handle $res already exist. \002Use:\002 !addvoice <nick> <handle> <f>"
         return 0
      }
      adduser $res [maskhost $hostmask]
      chattr $res +p|+v $chan
      puthelp "NOTICE $a :New user: $res"
      puthelp "NOTICE $a :$nick added in $chan voicelist and party-line with the handle: $res."
      puthelp "NOTICE $nick :You have been added in $chan voicelist and party-line by $a with the handle: $res."
      puthelp "NOTICE $nick :You must set a password type: \002/msg $botnick PASS <your_password>\002"
      putserv "MODE $chan +v $nick"
      return 0
   }
   if {[matchattr $hand -|+v $chan] == 1} {
      puthelp "NOTICE $a :$nick is already voice in $chan with this handle: $hand"
   } else {
      chattr $hand --|+v $chan
      puthelp "NOTICE $a :$nick added in $chan voicelist with this handle: $hand."
      puthelp "NOTICE $nick :You have been added in $chan voicelist by $a with the handle: $hand."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan +v $nick"
      return 0
   }
   puthelp "NOTICE $a :Sorry, but i can't voice $nick because i'm not op in $chan !!!"
   return 0
}

### delvoice <password> <nick> <#chan>

proc msg_delvoice {a b c arg} {
   global botnick
   set pass [lindex $arg 0]
   set nick [strlwr [lindex $arg 1]]
   set chan [strlwr [lindex $arg 2]]
   set bot [strlwr $botnick]
   if {$arg == ""} {
      puthelp "NOTICE $a :\002Usage:\002 delvoice <password> <nick> <#chan>"
      return 0
   }
   if {[passwdok $c $pass] == 0} {
      puthelp "NOTICE $a :Invalid password."
      puthelp "NOTICE $a :\002Usage:\002 delvoice <password> <nick> <#chan>"
      return 0
   }
   if {$chan == ""} {
      puthelp "NOTICE $a :\002Usage:\002 delvoice <password> <nick> <#chan>"
      return 0
   }
   if {([validchan $chan] == 0 && [isdynamic $chan] == 0)} {
      puthelp "NOTICE $a :I'm not on $chan "
      return 0
   }
   if {[matchattr $c m|m $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but you are not master in $chan."
      return 0
   }
   set hand [nick2hand $nick $chan]
   if {[onchan $nick $chan] == 0} {
      puthelp "NOTICE $a :Sorry, but i don't find $nick in $chan."
      return 0
   }
   if {$nick == $bot} {
      puthelp "NOTICE $a :Yeah right, like I'm going to let you delvoice ME!"
      return 0
   }
   if {[validuser $hand] == 0} {
      puthelp "NOTICE $a :$nick is not a registered user."
      putserv "MODE $chan -v $nick"
      return 0
   }
   if {[matchattr $hand -|+v $chan] == 0} {
      puthelp "NOTICE $a :$nick is not voice in $chan"
   } else {
      chattr $hand --|-v $chan
      puthelp "NOTICE $a :$nick has been removed of $chan voicelist."
      puthelp "NOTICE $nick :You have been removed of $chan voicelist by $a."
   }
   if {[botisop $chan] == 1} {
      putserv "MODE $chan -v $nick"
      return 0
   }
   puthelp "NOTICE $a :Sorry, but i can't devoice $nick because i'm not op in $chan !!!"
   return 0
}

### help

proc msg_help {a b c d} {
   global version_lol
   *msg:help $a $b $c $d
   if {[matchattr $c o|o]==1} {
      puthelp "NOTICE $a :Msg commands of $version_lol:"
      if {[matchattr $c m|m]==1} {
         puthelp "NOTICE $a :banmask <pass> <mask> <#chan> \[time\] Ban a mask (time 0 = perm ban)."
         puthelp "NOTICE $a :addop <pass> <nick> <#chan> \[handle\] \[f\] Op an user in the bot."
         puthelp "NOTICE $a :delop <pass> <nick> <#chan> Deop an user of the bot."
         puthelp "NOTICE $a :addvoice <pass> <nick> <#chan> \[handle\] \[f\] Voice an user in the bot."
         puthelp "NOTICE $a :delvoice <pass> <nick> <#chan> Devoice an user of the bot."
      }
      puthelp "NOTICE $a :ban <pass> <nick> <#chan> \[time\] Ban an user (time 0 = perm ban)."
      puthelp "NOTICE $a :unban <password> <mask> <#chan> Unban a mask."
      puthelp "NOTICE $a :mode <password> <#chan> <flags> Put the requested flags at a chan."
      puthelp "NOTICE $a :whois <pass> <nick> <#chan> Show the handle of an user."
      puthelp "NOTICE $a :For troubles with my scripts or bugs report: \002lol@mail.dotcom.fr\002"
   }
}



################# END OF MSG COMMANDS #################

### END OF SCRIPT

putlog "\037*** Succeful LOADING OF $version_lol ***\037  Type \002.help-lol\002 for commands."
