#
# rgets.tcl by VR_Dude (email: vr_dude@geocities.com)
#  - v0.1 (1/29/98) 
#
# Greets: #scripting (http://test98.citeweb.net)
#
# Notes:
#   This tcl adds 3 procs (rgets, ropen, reof), which work like the regular
#   procs, but instead of reading text files from the start to end, they them
#   from end to start.
#
# Example:
#   set of [ropen /tmp/test]
#   while {![reof $of]} {puts [rgets $of]}
#   close $of
###########################################################################

proc rgets {{args ""}} {
  if {[llength $args] < 1 || [llength $args] > 2} {
    error "wrong \# args: should be \"rgets channelId ?varName?\""
  }
  set of [lindex $args 0] 
  if {[catch {tell $of} msg]} {error $msg}
  if {[llength $args] == 2} {upvar 1 [lindex $args 1] val;set up 1} {set up 0}
  set val ""
  while {[tell $of] > 1 && 
         [set tmp [seek $of -2 current ; read $of 1]] != "\n"} {
    set val $tmp$val
  }
  if {!$up} {return $val} {return [string length $val]} 
}
proc ropen {file} {set of [open $file r] ; seek $of 0 end ; return $of}
proc reof {of} {if {[tell $of] > 1} {return 0} {return 1}}

