#Eggdrop Toolz 1.1.0 by JBeam2
###################
#      MISC       # 
###################

set ver "1.1.0"
putlog "Eggdrop Toolz $ver by JBeam2...Loaded"


###################
#     BINDS       #        
###################

bind pub - !stats pub:stats
bind pub - !op pub:op
bind pub - !deop pub:deop
bind pub - !voice pub:voice
bind pub - !devoice pub:devoice
bind pub - !kick pub:kick
bind pub - !ban pub:ban
bind pub - !join pub:join
bind pub - !part pub:part
bind pub - !adduser pub:adduser
bind pub - !rmuser pub:removeuser
bind pub - !say pub:say
bind pub - !act pub:act
bind pub - !help pub:help
bind pub - !ping pub:ping
bind pub - !chattr pub:chattr
bind join - * join:join
bind part - * part:part
bind msg - !auth msg:auth
bind msg - !say msg:say 
bind msg - !act msg:act
bind ctcr - PING ctcp:reply

###################
#    PROCEDURES   #
###################

set voiced "0"
set oped "0"
set regular "0"
 
proc pub:stats {nick2 uhost hand chan text} {
  global voiced oped regular
  foreach nick [chanlist $chan] {
    if {[isop $nick $chan]} {
      incr oped
    }
    if {[isop $nick $chan] == 0} {
      incr regular
    }
    if {[isvoice $nick $chan]} {
      incr voiced
    }
  }
  set regular [expr $regular - $voiced]
  putserv "PRIVMSG $chan :Channel stats for $chan"
  putserv "PRIVMSG $chan :\002\Op'd \002\ $oped"
  putserv "PRIVMSG $chan :\002\Voiced \002\ $voiced"
  putserv "PRIVMSG $chan :\002\Regular \002\ $regular"
  set oped "0"
  set voiced "0"
  set regular "0"
}

proc pub:op {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0]
    putserv "MODE $chan +o $whom"
  }
}

proc pub:deop {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0]
    putserv "MODE $chan -o $whom"
  }
}



proc pub:voice {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0] 
    putserv "MODE $chan +v $whom"
  }
}

proc pub:devoice {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0] 
    putserv "MODE $chan -v $whom"
  }
}

proc pub:kick {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0]
    set reason [lrange $text 1 end]
    putserv "KICK $chan $whom :$reason"
  }
}

proc pub:ban {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0]
    set host [lindex $text 1]
    set lifetime [lindex $text 2]
    set reason [lrange $text 3 end]
    newchanban $chan $host $nick $reason $lifetime 
    putserv "KICK $chan $whom :$reason"
  }
}       
   
proc pub:join {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set ch [lindex $text 0]
    channel add $ch
  }
}

proc pub:part {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set ch [lindex $text 0] 
    channel remove $ch
  }
}

proc pub:act {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set action [lrange $text 0 end]
    putmsg $chan "\001ACTION\ $action"
  }
}

proc pub:say {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set say [lrange $text 0 end]  
    putmsg $chan "$say"
  }
}

proc pub:adduser {nick uhost hand chan text} {
  global botnick
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0]
    set host [getchanhost $whom $chan]
    adduser $whom $host
    if {[validuser $whom]} {
     putmsg $whom "You have been added to my userfile"
     putmsg $whom "Please set a pass on me"
     putmsg $whom "To do so type /msg $botnick pass passuwant"
     putmsg $whom "Replace passuwant with the password you would like"
    }
  }
}

proc pub:rmuser {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0]
    deluser $whom
  }
}

proc pub:ping {nick uhost hand chan text} {
  putserv "PRIVMSG $nick :\001PING [unixtime]\001"
  putlog "!ping received from $nick"
  return 0
}

proc ctcp:reply {nick uhost hand dest key text} {
  if {$key == "PING"} {
    set utime [unixtime]
    set lagtime [expr $utime - $text]
    putserv "NOTICE $nick :You're ping reply is $lagtime seconds"
  }
}

proc pub:chattr {nick uhost hand chan text} {
  if {[matchattr $hand 3]} {
    set whom [lindex $text 0]
    set flags [lindex $text 1]
    chattr $whom $flags
  }
}  

proc msg:say {nick uhost hand text} {
  if {[matchattr $hand 3]} {
    set chan [lindex $text 0]
    set text2 [lrange $text 1 end]
    putmsg $chan "$text2"
  }
}

proc msg:act {nick uhost hand text} {
  if {[matchattr $hand 3]} {
    set chan [lindex $text 0]
    set act [lrange $text 1 end]
    putmsg $chan "\001ACTION\ $act"
  }
}

proc pub:help {nick uhost hand chan text} {
  global ver
  putserv "PRIVMSG $nick :Welcome to Eggdrop Toolz $ver by JBeam2"
  putserv "PRIVMSG $nick :-------------------------------------------"
  putserv "PRIVMSG $nick :All the commands below are to be used in the channel"
  putserv "PRIVMSG $nick :!op <nick> -- Op someone"
  putserv "PRIVMSG $nick :!deop <nick> -- Deop someone"
  putserv "PRIVMSG $nick :!voice <nick> -- Give someone voice"
  putserv "PRIVMSG $nick :!devoice <nick> -- Take away someone's voice"
  putserv "PRIVMSG $nick :!kick <nick> <reason> -- Kick someone"
  putserv "PRIVMSG $nick :!ban <nick> <host> <lifetime> <reason> -- Ban someone"
  putserv "PRIVMSG $nick :!join <channel> -- Make me join a channel"
  putserv "PRIVMSG $nick :!part <channel> -- Make me leave a channel"
  putserv "PRIVMSG $nick :!adduser <nick> -- Add a user"
  putserv "PRIVMSG $nick :!rmuser <nick> -- Remove a user"
  putserv "PRIVMSG $nick :!say <message> -- Make me say something"
  putserv "PRIVMSG $nick :!act <action> -- Make me act something"
  putserv "PRIVMSG $nick :!ping -- Makes me ping you **"
  putserv "PRIVMSG $nick :!stats -- Tells you how many ops, voiced, and regular users there are"
  putserv "PRIVMSG $nick :!chattr <nick> <flags> -- Give someone extra flags"
  putserv "PRIVMSG $nick :-------------------------------------------"
  putserv "PRIVMSG $nick :The following commands below are to be used via message to me"
  putserv "PRIVMSG $nick :!act <chan> <action> -- Make me act something"
  putserv "PRIVMSG $nick :!say <chan> <text> -- Make me say something"
  putserv "PRIVMSG $nick :!auth <password> -- Authenticate yourself"
  putserv "PRIVMSG $nick :----------------------------------------------"
  putserv "PRIVMSG $nick :You must have Authenticate yourself to use all commands except !ping"
  putserv "PRIVMSG $nick :For authentication to work properly you must have +o on the bot and you must include the correct password when you type !auth pass"
  putserv "PRIVMSG $nick :Any thing with a ** beside it means that you don't have to be authenticated to use it"
}

proc msg:auth {nick uhost hand text} {
  set passy [lindex $text 0]
  if {[matchattr $hand o]} {
    if {[passwdok $hand $passy] == 1} {
      putserv "PRIVMSG $nick :Authentication Successful"
      chattr $hand +3
    }  
  }
  if {[matchattr $hand o] == 0} {
    putserv "PRIVMSG $nick :Authentication Failed"
  }
  if {[matchattr $hand o]} {
    if {[passwdok $hand $passy] == 0} {
      putserv "PRIVMSG $nick :Authentication Failed"
    }
  }
}
proc join:join {nick uhost hand chan} {
  chattr $hand -3
}
proc part:part {nick uhost hand chan} {
  chattr $hand -3
}