###
#Translator 1.1 by dw (dw@mindless.com)
#
# For eggdrop1.3.x and tcl8.x (uses babelfish at altavista)
# v1.0 (19/12-98) -- first release
# v1.1 (21/12-98) -- added some user settings
#                    added bindings for msg and dcc
#                    made it friendly with multichanbots
#
# Installation:  tar -zxf transl1.1.tgz
#                mv translator* ~/eggdrop/scripts/
#                chmod 700 ~/eggdrop/scripts/translator
#                echo source scripts/translator.tcl >> ~/eggdrop/<bot>.conf
#                .rehash
#
# Usage: !translate <fromlang> <tolang> <text>
#       /msg <botnick> translate <fromlang> <tolang> <text>
#       .translate <fromlang> <tolang> <text>
# 
# Note: works as standalone app too.. 
#           ./translator <fromlang> <tolang> <text to translate>  
###

####SETTINGS####

#set channels that !translate should work in
set chans "#lamechan1 #otherchan"

#set write the respons to !public querys in the channel("0")
# or in private notice("1")?
# default in channel "1"
set noverbose "0"

#userflag needed to use pub and msg translation
#default "o" (global or channel op)
#type "-" if the user don't need to have a botflag
set pflag "o"

#userflag needed in dcc (default "-")
set dflag "-"

###END OF SETTINGS####





bind pubm $pflag|$pflag "% !translate % % *" pubm_transl
bind pubm $pflag|$pflag "% !translate" phelp_transl
bind msgm $pflag|$pflag "translate % % *" msgm_transl
bind msgm $pflag|$pflag "translate" mhelp_transl
bind dcc $dflag|$dflag "translate" dcc_transl
set helptext "Usage: \002MSG:\002 /msg <botnick> translate <args>  \002PUB:\002 !translate <args>  \002DCC:\002 .translate <args> \002Args is:\002 <fromlang> <tolang> <text to translate> \002:\002 Valid langs is.. english, french, german, italian, portuguese and spanish. \002(\002dw@undernet\002)\002"

proc phelp_transl {ni uh ha ch text} {
global noverbose helptext chans
if {[string first [string tolower $ch] [string tolower $chans]] == "-1"} { return 0 }
if {$noverbose} { putserv "NOTICE $ni :$helptext" } {
putserv "PRIVMSG $ch :$helptext" }
}
proc mhelp_transl {ni uh ha text} {
global noverbose helptext
putserv "PRIVMSG $ni :$helptext"
}
proc pubm_transl {ni uh ha ch text} {
global noverbose
set text [split $text]
set text [lreplace $text 0 0]
set froml [string tolower [lindex $text 0]]
set tol [string tolower [lindex $text 1]]  
set text [lrange $text 2 end]
if {$noverbose} { set cmd "NOTICE $ni" } { set cmd "PRIVMSG $ch" }
putserv "$cmd :Translating '[join $text]' from '$froml' to '$tol' wait.."
eval catch \{exec scripts/translator $froml $tol $text\} blah
putserv "$cmd :$blah"
}
proc msgm_transl {ni uh ha text} {
set text [split $text]
set text [lreplace $text 0 0]
set froml [string tolower [lindex $text 0]]
set tol [string tolower [lindex $text 1]]  
set text [lrange $text 2 end]
putserv "PRIVMSG $ni :Translating '[join $text]' from '$froml' to '$tol' wait.."
eval catch \{exec scripts/translator $froml $tol $text\} blah
putserv "PRIVMSG $ni :$blah"
}
proc dcc_transl {ha idx text} {
global helptext
set text [split $text]
if {$text == ""} { putdcc $idx $helptext } {
set froml [string tolower [lindex $text 0]]
set tol [string tolower [lindex $text 1]]  
set text [lrange $text 2 end]
putdcc $idx "Translating '[join $text]' from '$froml' to '$tol' wait.."
eval catch \{exec scripts/translator $froml $tol $text\} blah
putdcc $idx "$blah"
 }
}
putlog "Translator 1.1 by dw@undernet...loaded"